'From Smalltalk-80, version 2, of April 1, 1983 on 16 August 1983 at 6:41:10 pm'!

Stream subclass: #UnixProcess
	instanceVariableNames: 'readFd writeFd pid nextChar '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Files-Berkeley Unix'!


!UnixProcess methodsFor: 'primitives'!

primitiveFork: command
	"fork a subprocess from command string"
	<primitive: 213>.
	^self primitiveFailed! !

!UnixProcess methodsFor: 'testing'!

atEnd
	nextChar isNil ifTrue: [nextChar _ self next].
	^nextChar isNil! !

!UnixProcess methodsFor: 'closing'!

close
	UnixFile primitiveCloseFd: readFd ; primitiveCloseFd: writeFd! !

!UnixProcess methodsFor: 'accessing'!

contents
	|stream |
	stream _ WriteStream on: String  new.
	self do: [:c | stream nextPut:c].
	^stream contents!

next
	| s c |
	nextChar notNil
		ifTrue: 
			[c _ nextChar.
			nextChar _ nil.
			^c].
	s _ String new: 1.
	
	[readFd < 0 ifTrue: [^nil].
	(c _ UnixFile
				primitiveReadFd: readFd
				buffer: s
				length: 1) = 0
		ifTrue: 
			[self close.
			readFd _ -1].
	c > 0] whileFalse.
	^s at: 1!

nextPut: aChar
	| s |
	s _ String with: aChar.
	UnixFile
		primitiveWriteFd: writeFd
		buffer: s
		length: 1.
	^aChar! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

UnixProcess class
	instanceVariableNames: ''!


!UnixProcess class methodsFor: 'instance creation'!

on: aString
	^self basicNew primitiveFork: aString
	"(UnixProcess on:'/bin/date') contents"! !