'From Smalltalk-80, version 2, of April 1, 1983 on 29 October 1983 at 2:17:33 am'!

!SystemDictionary methodsFor: 'memory space'!
oldLeft
	"Answer the number of free words of Old space minus the words of survivors.
	The survivors are counted because they may be enroute to promotion.
	Added for Berkeley Smalltalk by DMU, 10/83."
	
	<primitive: 215>
	self primitiveFailed
	"Smalltalk oldLeft"! !

!SystemDictionary methodsFor: 'system compression'!
reorganize
	"perform offline reorganization: global mark and sweep with depth first reordering for Old space.  Puts out messages to the screen while doing so."

	| before after |
	before _ self oldLeft.
	Transcript show: before printString, ' words left in old space before reorganization.'; cr.
	self reorganizePrimitive.
	after _ self oldLeft.
	Transcript show: after printString, ' words left in old space after reorganization.'; cr.
	Transcript show: 'reclaimed ', (after - before) printString, ' words.'; cr
	"Smalltalk reorganize"! !
	
!SystemDictionary methodsFor: 'private'!
reorganizePrimitive
	"Primitive method.  Does not tell you what it is doing.  Users should use the message reorganize instead of this one."

	<primitive: 214>
	^self primitiveFailed
	"Smalltalk reorganizePrimitive"! !

!SystemDictionary methodsFor: 'private'!
lowSpaceNotificationLoop
	[true]
		whileTrue: 
			[LowSpaceSemaphore wait.
			self oldLeft <= self coreLeftLimit
				ifTrue: 
					[ScheduledControllers interruptName: 'Space is Low'.
					(BinaryChoice message: 'Do you wish to reclaim old space (takes 5 min.)?')
						ifTrue: [self reorganize.
							ScheduledControllers restore]
						ifFalse: [self halt: 'Proceed to restart space notification, or close after a snapshot.']]
				ifFalse: 
					[ScheduledControllers interruptName: 'Infinite recursion'.
					self halt: 'Proceed to restart space notification, or close after a snapshot.'].
			self resetLowSpaceSignal]! !
