!ScreenController methodsFor: 'As yet unclassified'!

openExaminer
	| examinerClass examinerDepth |
	FillInTheBlank
		request: 'Class to examine:'
		displayAt: Sensor cursorPoint
		centered: true
		action: [ :answer | examinerClass _
				Smalltalk at: (answer asSymbol) ]
		initialAnswer: 'Object'.
	((examinerClass subclasses) size) = 0 ifTrue:
		[ examinerClass _ examinerClass superclass ].
	FillInTheBlank
		request: 'Depth to examine:'
		displayAt: Sensor cursorPoint
		centered: true
		action: [ :answer | examinerDepth _ (answer asNumber) ]
		initialAnswer: '7'.
	examinerDepth < 2 ifTrue: [ examinerDepth _ 2 ].
	examinerDepth > 10 ifTrue: [ examinerDepth _ 10 ].
	ExaminerView openOn: examinerClass withDepth: examinerDepth.
!

openNavigator
	| aClass |
	FillInTheBlank
		request: 'Class to navigate:'
		displayAt: Sensor cursorPoint
		centered: true
		action: [ :answer | aClass _
				Smalltalk at: (answer asSymbol) ]
		initialAnswer: 'Object'.
	((aClass subclasses) size) = 0 ifTrue: [ aClass _ aClass superclass ].
	NavigatorView openOn: aClass.
!

openProtocolBrowser
	| aClass |
	FillInTheBlank
		request: 'Which class'' protocol?'
		displayAt: Sensor cursorPoint
		centered: true
		action: [ :answer | aClass _
				Smalltalk at: (answer asSymbol) ]
		initialAnswer: 'Object'.
	ProtocolBrowser openForClass: aClass.! !

!ScreenController class methodsFor: 'class initialization'!

initialize
	ScreenYellowButtonMenu _
		PopUpMenu
			labels: 
'restore display
exit project
open project
file list
browse
navigate
examine
protocol browser
workspace
system transcript
system workspace
save
quit'
			lines: #(3 4 8 10).
	ScreenYellowButtonMessages _
			#(restoreDisplay exitProject openProject 
			openFileList openBrowser openNavigator openExaminer openProtocolBrowser openWorkspace openTranscript openSystemWorkspace
			save quit).
	ScreenController allInstancesDo: [:c | c initializeYellowButtonMenu].! !

ScreenController initialize!

