
Object subclass: #Examiner
	instanceVariableNames: 'depth classList selectionList menuList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Interface-Browser'!

!Examiner methodsFor: 'level1 list'!
level1List
	^ classList at: 1
! !

!Examiner methodsFor: 'level1 list'!
level1Menu
	| menu |
	menu _ menuList at: 1.
	menu == nil ifTrue:
		[ menu _ ActionMenu
			  labels: 'examine\browse\instance lookup\class lookup' withCRs
			  lines: #(1 2)
			  selectors: #(examineLevel1 browseLevel1 lookupLevel1Instance lookupLevel1Class).
		  menuList at: 1 put: menu ].
	^ menu
! !

!Examiner methodsFor: 'level1 list'!
level1Name
	^ selectionList at: 1
! !

!Examiner methodsFor: 'level1 list'!
level1Name: selection
	selectionList at: 1 put: (self getName: selection).
! !

!Examiner methodsFor: 'level1 functions'!
browseLevel1
	(selectionList at: 1) == nil ifTrue: [ ^self ].
	Browser newOnClass: (selectionList at: 1).
! !

!Examiner methodsFor: 'level1 functions'!
examineLevel1
	self examine: 1.
	self changeLevel2.
! !

!Examiner methodsFor: 'level1 functions'!
lookupLevel1Instance
	(selectionList at: 1) == nil ifTrue: [ ^self ].
	self lookupSelectorFrom: (selectionList at: 1).
! !

!Examiner methodsFor: 'level1 functions'!
lookupLevel1Class
	(selectionList at: 1) == nil ifTrue: [ ^self ].
	self lookupSelectorFrom: ((selectionList at: 1) class).
! !

!Examiner methodsFor: 'level2 list'!
level2List
	^ classList at: 2
! !

!Examiner methodsFor: 'level2 list'!
level2Menu
	| menu |
	menu _ menuList at: 2.
	menu == nil ifTrue:
	  [ depth ~= 2
	     ifTrue:
		[ menu _ ActionMenu
		  labels: 'examine\clear\browse\instance lookup\class lookup' withCRs
		  lines: #(3 4)
		  selectors: #(examineLevel2 clearLevel2 browseLevel2 lookupLevel2Instance lookupLevel2Class) ]
	     ifFalse:
		[ menu _ ActionMenu
		  labels: 'clear\browse\instance lookup\class lookup' withCRs
		  lines: #(1 2)
		  selectors: #(clearLevel2 browseLevel2 lookupLevel2Instance lookupLevel2Class) ].
	    menuList at: 2 put: menu ].
	^ menu
! !

!Examiner methodsFor: 'level2 list'!
level2Name
	^ selectionList at: 2
! !

!Examiner methodsFor: 'level2 list'!
level2Name: selection
	selectionList at: 2 put: (self getName: selection).
! !

!Examiner methodsFor: 'level2 functions'!
browseLevel2
	(selectionList at: 2) == nil ifTrue: [ ^self ].
	Browser newOnClass: (selectionList at: 2).
! !

!Examiner methodsFor: 'level2 functions'!
examineLevel2
	self examine: 2.
	self changeLevel3.
! !

!Examiner methodsFor: 'level2 functions'!
changeLevel2
	depth ~= 2 ifTrue: [ self changeLevel3 ].
	self changed: #level2Name.
! !

!Examiner methodsFor: 'level2 functions'!
clearLevel2
	depth ~= 2 ifTrue: [ self clearLevel3 ].
	classList at: 2 put: nil.
	self changed: #level2Name.
! !

!Examiner methodsFor: 'level2 functions'!
lookupLevel2Instance
	(selectionList at: 2) == nil ifTrue: [ ^self ].
	self lookupSelectorFrom: (selectionList at: 2).
! !

!Examiner methodsFor: 'level2 functions'!
lookupLevel2Class
	(selectionList at: 2) == nil ifTrue: [ ^self ].
	self lookupSelectorFrom: ((selectionList at: 2) class).
! !

!Examiner methodsFor: 'level3 list'!
level3List
	^ classList at: 3
! !

!Examiner methodsFor: 'level3 list'!
level3Menu
	| menu |
	menu _ menuList at: 3.
	menu == nil ifTrue:
	  [ depth ~= 3
	     ifTrue:
		[ menu _ ActionMenu
		  labels: 'examine\clear\browse\instance lookup\class lookup' withCRs
		  lines: #(3 4)
		  selectors: #(examineLevel3 clearLevel3 browseLevel3 lookupLevel3Instance lookupLevel3Class) ]
	     ifFalse:
		[ menu _ ActionMenu
		  labels: 'clear\browse\instance lookup\class lookup' withCRs
		  lines: #(1 2)
		  selectors: #(clearLevel3 browseLevel3 lookupLevel3Instance lookupLevel3Class) ].
	    menuList at: 3 put: menu ].
	^ menu
! !

!Examiner methodsFor: 'level3 list'!
level3Name
	^ selectionList at: 3
! !

!Examiner methodsFor: 'level3 list'!
level3Name: selection
	selectionList at: 3 put: (self getName: selection).
! !

!Examiner methodsFor: 'level3 functions'!
browseLevel3
	(selectionList at: 3) == nil ifTrue: [ ^self ].
	Browser newOnClass: (selectionList at: 3).
! !

!Examiner methodsFor: 'level3 functions'!
examineLevel3
	self examine: 3.
	self changeLevel4.
! !

!Examiner methodsFor: 'level3 functions'!
changeLevel3
	depth ~= 3 ifTrue: [ self changeLevel4 ].
	self changed: #level3Name.
! !

!Examiner methodsFor: 'level3 functions'!
clearLevel3
	depth ~= 3 ifTrue: [ self clearLevel4 ].
	classList at: 3 put: nil.
	self changed: #level3Name.
! !

!Examiner methodsFor: 'level3 functions'!
lookupLevel3Instance
	(selectionList at: 3) == nil ifTrue: [ ^self ].
	self lookupSelectorFrom: (selectionList at: 3).
! !

!Examiner methodsFor: 'level3 functions'!
lookupLevel3Class
	(selectionList at: 3) == nil ifTrue: [ ^self ].
	self lookupSelectorFrom: ((selectionList at: 3) class).
! !

!Examiner methodsFor: 'level4 list'!
level4List
	^ classList at: 4
! !

!Examiner methodsFor: 'level4 list'!
level4Menu
	| menu |
	menu _ menuList at: 4.
	menu == nil ifTrue:
	  [ depth ~= 4
	     ifTrue:
		[ menu _ ActionMenu
		  labels: 'examine\clear\browse\instance lookup\class lookup' withCRs
		  lines: #(3 4)
		  selectors: #(examineLevel4 clearLevel4 browseLevel4 lookupLevel4Instance lookupLevel4Class) ]
	     ifFalse:
		[ menu _ ActionMenu
		  labels: 'clear\browse\instance lookup\class lookup' withCRs
		  lines: #(1 2)
		  selectors: #(clearLevel4 browseLevel4 lookupLevel4Instance lookupLevel4Class) ].
	    menuList at: 4 put: menu ].
	^ menu
! !

!Examiner methodsFor: 'level4 list'!
level4Name
	^ selectionList at: 4
! !

!Examiner methodsFor: 'level4 list'!
level4Name: selection
	selectionList at: 4 put: (self getName: selection).
! !

!Examiner methodsFor: 'level4 functions'!
browseLevel4
	(selectionList at: 4) == nil ifTrue: [ ^self ].
	Browser newOnClass: (selectionList at: 4).
! !

!Examiner methodsFor: 'level4 functions'!
examineLevel4
	self examine: 4.
	self changeLevel5.
! !

!Examiner methodsFor: 'level4 functions'!
changeLevel4
	depth ~= 4 ifTrue: [ self changeLevel5 ].
	self changed: #level4Name.
! !

!Examiner methodsFor: 'level4 functions'!
clearLevel4
	depth ~= 4 ifTrue: [ self clearLevel5 ].
	classList at: 4 put: nil.
	self changed: #level4Name.
! !

!Examiner methodsFor: 'level4 functions'!
lookupLevel4Instance
	(selectionList at: 4) == nil ifTrue: [ ^self ].
	self lookupSelectorFrom: (selectionList at: 4).
! !

!Examiner methodsFor: 'level4 functions'!
lookupLevel4Class
	(selectionList at: 4) == nil ifTrue: [ ^self ].
	self lookupSelectorFrom: ((selectionList at: 4) class).
! !

!Examiner methodsFor: 'level5 list'!
level5List
	^ classList at: 5
! !

!Examiner methodsFor: 'level5 list'!
level5Menu
	| menu |
	menu _ menuList at: 5.
	menu == nil ifTrue:
	  [ depth ~= 5
	     ifTrue:
		[ menu _ ActionMenu
		  labels: 'examine\clear\browse\instance lookup\class lookup' withCRs
		  lines: #(3 4)
		  selectors: #(examineLevel5 clearLevel5 browseLevel5 lookupLevel5Instance lookupLevel5Class) ]
	     ifFalse:
		[ menu _ ActionMenu
		  labels: 'clear\browse\instance lookup\class lookup' withCRs
		  lines: #(1 2)
		  selectors: #(clearLevel5 browseLevel5 lookupLevel5Instance lookupLevel5Class) ].
	    menuList at: 5 put: menu ].
	^ menu
! !

!Examiner methodsFor: 'level5 list'!
level5Name
	^ selectionList at: 5
! !

!Examiner methodsFor: 'level5 list'!
level5Name: selection
	selectionList at: 5 put: (self getName: selection).
! !

!Examiner methodsFor: 'level5 functions'!
browseLevel5
	(selectionList at: 5) == nil ifTrue: [ ^self ].
	Browser newOnClass: (selectionList at: 5).
! !

!Examiner methodsFor: 'level5 functions'!
examineLevel5
	self examine: 5.
	self changeLevel6.
! !

!Examiner methodsFor: 'level5 functions'!
changeLevel5
	depth ~= 5 ifTrue: [ self changeLevel6 ].
	self changed: #level5Name.
! !

!Examiner methodsFor: 'level5 functions'!
clearLevel5
	depth ~= 5 ifTrue: [ self clearLevel6 ].
	classList at: 5 put: nil.
	self changed: #level5Name.
! !

!Examiner methodsFor: 'level5 functions'!
lookupLevel5Instance
	(selectionList at: 5) == nil ifTrue: [ ^self ].
	self lookupSelectorFrom: (selectionList at: 5).
! !

!Examiner methodsFor: 'level5 functions'!
lookupLevel5Class
	(selectionList at: 5) == nil ifTrue: [ ^self ].
	self lookupSelectorFrom: ((selectionList at: 5) class).
! !

!Examiner methodsFor: 'level6 list'!
level6List
	^ classList at: 6
! !

!Examiner methodsFor: 'level6 list'!
level6Menu
	| menu |
	menu _ menuList at: 6.
	menu == nil ifTrue:
	  [ depth ~= 6
	     ifTrue:
		[ menu _ ActionMenu
		  labels: 'examine\clear\browse\instance lookup\class lookup' withCRs
		  lines: #(3 4)
		  selectors: #(examineLevel6 clearLevel6 browseLevel6 lookupLevel6Instance lookupLevel6Class) ]
	     ifFalse:
		[ menu _ ActionMenu
		  labels: 'clear\browse\instance lookup\class lookup' withCRs
		  lines: #(1 2)
		  selectors: #(clearLevel6 browseLevel6 lookupLevel6Instance lookupLevel6Class) ].
	    menuList at: 6 put: menu ].
	^ menu
! !

!Examiner methodsFor: 'level6 list'!
level6Name
	^ selectionList at: 6
! !

!Examiner methodsFor: 'level6 list'!
level6Name: selection
	selectionList at: 6 put: (self getName: selection).
! !

!Examiner methodsFor: 'level6 functions'!
browseLevel6
	(selectionList at: 6) == nil ifTrue: [ ^self ].
	Browser newOnClass: (selectionList at: 6).
! !

!Examiner methodsFor: 'level6 functions'!
examineLevel6
	self examine: 6.
	self changeLevel7.
! !

!Examiner methodsFor: 'level6 functions'!
changeLevel6
	depth ~= 6 ifTrue: [ self changeLevel7 ].
	self changed: #level6Name.
! !

!Examiner methodsFor: 'level6 functions'!
clearLevel6
	depth ~= 6 ifTrue: [ self clearLevel7 ].
	classList at: 6 put: nil.
	self changed: #level6Name.
! !

!Examiner methodsFor: 'level6 functions'!
lookupLevel6Instance
	(selectionList at: 6) == nil ifTrue: [ ^self ].
	self lookupSelectorFrom: (selectionList at: 6).
! !

!Examiner methodsFor: 'level6 functions'!
lookupLevel6Class
	(selectionList at: 6) == nil ifTrue: [ ^self ].
	self lookupSelectorFrom: ((selectionList at: 6) class).
! !

!Examiner methodsFor: 'level7 list'!
level7List
	^ classList at: 7
! !

!Examiner methodsFor: 'level7 list'!
level7Menu
	| menu |
	menu _ menuList at: 7.
	menu == nil ifTrue:
	  [ depth ~= 7
	     ifTrue:
		[ menu _ ActionMenu
		  labels: 'examine\clear\browse\instance lookup\class lookup' withCRs
		  lines: #(3 4)
		  selectors: #(examineLevel7 clearLevel7 browseLevel7 lookupLevel7Instance lookupLevel7Class) ]
	     ifFalse:
		[ menu _ ActionMenu
		  labels: 'clear\browse\instance lookup\class lookup' withCRs
		  lines: #(1 2)
		  selectors: #(clearLevel7 browseLevel7 lookupLevel7Instance lookupLevel7Class) ].
	    menuList at: 7 put: menu ].
	^ menu
! !

!Examiner methodsFor: 'level7 list'!
level7Name
	^ selectionList at: 7
! !

!Examiner methodsFor: 'level7 list'!
level7Name: selection
	selectionList at: 7 put: (self getName: selection).
! !

!Examiner methodsFor: 'level7 functions'!
browseLevel7
	(selectionList at: 7) == nil ifTrue: [ ^self ].
	Browser newOnClass: (selectionList at: 7).
! !

!Examiner methodsFor: 'level7 functions'!
examineLevel7
	self examine: 7.
	self changeLevel8.
! !

!Examiner methodsFor: 'level7 functions'!
changeLevel7
	depth ~= 7 ifTrue: [ self changeLevel8 ].
	self changed: #level7Name.
! !

!Examiner methodsFor: 'level7 functions'!
clearLevel7
	depth ~= 7 ifTrue: [ self clearLevel8 ].
	classList at: 7 put: nil.
	self changed: #level7Name.
! !

!Examiner methodsFor: 'level7 functions'!
lookupLevel7Instance
	(selectionList at: 7) == nil ifTrue: [ ^self ].
	self lookupSelectorFrom: (selectionList at: 7).
! !

!Examiner methodsFor: 'level7 functions'!
lookupLevel7Class
	(selectionList at: 7) == nil ifTrue: [ ^self ].
	self lookupSelectorFrom: ((selectionList at: 7) class).
! !

!Examiner methodsFor: 'level8 list'!
level8List
	^ classList at: 8
! !

!Examiner methodsFor: 'level8 list'!
level8Menu
	| menu |
	menu _ menuList at: 8.
	menu == nil ifTrue:
	  [ depth ~= 8
	     ifTrue:
		[ menu _ ActionMenu
		  labels: 'examine\clear\browse\instance lookup\class lookup' withCRs
		  lines: #(3 4)
		  selectors: #(examineLevel8 clearLevel8 browseLevel8 lookupLevel8Instance lookupLevel8Class) ]
	     ifFalse:
		[ menu _ ActionMenu
		  labels: 'clear\browse\instance lookup\class lookup' withCRs
		  lines: #(1 2)
		  selectors: #(clearLevel8 browseLevel8 lookupLevel8Instance lookupLevel8Class) ].
	    menuList at: 8 put: menu ].
	^ menu
! !

!Examiner methodsFor: 'level8 list'!
level8Name
	^ selectionList at: 8
! !

!Examiner methodsFor: 'level8 list'!
level8Name: selection
	selectionList at: 8 put: (self getName: selection).
! !

!Examiner methodsFor: 'level8 functions'!
browseLevel8
	(selectionList at: 8) == nil ifTrue: [ ^self ].
	Browser newOnClass: (selectionList at: 8).
! !

!Examiner methodsFor: 'level8 functions'!
examineLevel8
	self examine: 8.
	self changeLevel9.
! !

!Examiner methodsFor: 'level8 functions'!
changeLevel8
	depth ~= 8 ifTrue: [ self changeLevel9 ].
	self changed: #level8Name.
! !

!Examiner methodsFor: 'level8 functions'!
clearLevel8
	depth ~= 8 ifTrue: [ self clearLevel9 ].
	classList at: 8 put: nil.
	self changed: #level8Name.
! !

!Examiner methodsFor: 'level8 functions'!
lookupLevel8Instance
	(selectionList at: 8) == nil ifTrue: [ ^self ].
	self lookupSelectorFrom: (selectionList at: 8).
! !

!Examiner methodsFor: 'level8 functions'!
lookupLevel8Class
	(selectionList at: 8) == nil ifTrue: [ ^self ].
	self lookupSelectorFrom: ((selectionList at: 8) class).
! !

!Examiner methodsFor: 'level9 list'!
level9List
	^ classList at: 9
! !

!Examiner methodsFor: 'level9 list'!
level9Menu
	| menu |
	menu _ menuList at: 9.
	menu == nil ifTrue:
	  [ depth ~= 9
	     ifTrue:
		[ menu _ ActionMenu
		  labels: 'examine\clear\browse\instance lookup\class lookup' withCRs
		  lines: #(3 4)
		  selectors: #(examineLevel9 clearLevel9 browseLevel9 lookupLevel9Instance lookupLevel9Class) ]
	     ifFalse:
		[ menu _ ActionMenu
		  labels: 'clear\browse\instance lookup\class lookup' withCRs
		  lines: #(1 2)
		  selectors: #(clearLevel9 browseLevel9 lookupLevel9Instance lookupLevel9Class) ].
	    menuList at: 9 put: menu ].
	^ menu
! !

!Examiner methodsFor: 'level9 list'!
level9Name
	^ selectionList at: 9
! !

!Examiner methodsFor: 'level9 list'!
level9Name: selection
	selectionList at: 9 put: (self getName: selection).
! !

!Examiner methodsFor: 'level9 functions'!
browseLevel9
	(selectionList at: 9) == nil ifTrue: [ ^self ].
	Browser newOnClass: (selectionList at: 9).
! !

!Examiner methodsFor: 'level9 functions'!
examineLevel9
	self examine: 9.
	self changeLevel10.
! !

!Examiner methodsFor: 'level9 functions'!
changeLevel9
	depth ~= 9 ifTrue: [ self changeLevel10 ].
	self changed: #level9Name.
! !

!Examiner methodsFor: 'level9 functions'!
clearLevel9
	depth ~= 9 ifTrue: [ self clearLevel10 ].
	classList at: 9 put: nil.
	self changed: #level9Name.
! !

!Examiner methodsFor: 'level9 functions'!
lookupLevel9Instance
	(selectionList at: 9) == nil ifTrue: [ ^self ].
	self lookupSelectorFrom: (selectionList at: 9).
! !

!Examiner methodsFor: 'level9 functions'!
lookupLevel9Class
	(selectionList at: 9) == nil ifTrue: [ ^self ].
	self lookupSelectorFrom: ((selectionList at: 9) class).
! !

!Examiner methodsFor: 'level10 list'!
level10List
	^ classList at: 10
! !

!Examiner methodsFor: 'level10 list'!
level10Menu
	| menu |
	menu _ menuList at: 10.
	menu == nil ifTrue:
	  [ depth ~= 10
	     ifTrue:
		[ menu _ ActionMenu
		  labels: 'examine\clear\browse\instance lookup\class lookup' withCRs
		  lines: #(3 4)
		  selectors: #(examineLevel10 clearLevel10 browseLevel10 lookupLevel10Instance lookupLevel10Class) ]
	     ifFalse:
		[ menu _ ActionMenu
		  labels: 'clear\browse\instance lookup\class lookup' withCRs
		  lines: #(1 2)
		  selectors: #(clearLevel10 browseLevel10 lookupLevel10Instance lookupLevel10Class) ].
	    menuList at: 10 put: menu ].
	^ menu
! !

!Examiner methodsFor: 'level10 list'!
level10Name
	^ selectionList at: 10
! !

!Examiner methodsFor: 'level10 list'!
level10Name: selection
	selectionList at: 10 put: (self getName: selection).
! !

!Examiner methodsFor: 'level10 functions'!
browseLevel10
	(selectionList at: 10) == nil ifTrue: [ ^self ].
	Browser newOnClass: (selectionList at: 10).
! !

!Examiner methodsFor: 'level10 functions'!
changeLevel10
	depth ~= 10 ifTrue: [ self changeLevel0 ].
	self changed: #level10Name.
! !

!Examiner methodsFor: 'level10 functions'!
clearLevel10
	depth ~= 10 ifTrue: [ self clearLevel0 ].
	classList at: 10 put: nil.
	self changed: #level10Name.
! !

!Examiner methodsFor: 'level10 functions'!
lookupLevel10Instance
	(selectionList at: 10) == nil ifTrue: [ ^self ].
	self lookupSelectorFrom: (selectionList at: 10).
! !

!Examiner methodsFor: 'level10 functions'!
lookupLevel10Class
	(selectionList at: 10) == nil ifTrue: [ ^self ].
	self lookupSelectorFrom: ((selectionList at: 10) class).
! !

!Examiner methodsFor: 'initialization'!
on: root to: numberOfWindows
	depth _ numberOfWindows.
	classList _ Array new: numberOfWindows.
	selectionList _ Array new: numberOfWindows.
	menuList _ Array new: numberOfWindows.
	classList at: 1 put: (self addSubclasses: root to: nil).
! !

!Examiner methodsFor: 'private'!
getName: selection
	selection == nil ifTrue: [ ^nil ].
	(selection at: 1) = $- ifTrue: [ ^nil ].
	^ (Smalltalk at: (selection asSymbol))
! !

!Examiner methodsFor: 'private'!
examine: level
	| selection |
	selection _ selectionList at: level.
	selection == nil ifTrue:
	    [ (level + 1) to: depth do: [ :i | classList at: i put: nil ].
	      1 to: ((classList at: level) size) do:
		[ :i | selectionList at: level
			put: (self getName: ((classList at: level) at: i)).
		     (selectionList at: level) ~~ nil ifTrue:
			[ self examine: level ]].
	      selectionList at: level put: nil.
	      ^ self ].
	((selection subclasses) size) = 0 ifTrue: [ ^self ].
	selection == Class ifTrue: [ ^self ].
	level < depth ifTrue:
		[ classList at: (level+1) put:
			(self addSubclasses: selection to:
				(classList at: (level+1))).
		  (selection subclasses) do:
			[ :e | selectionList at: (level+1) put: e.
				self examine: level+1 ]].
! !

!Examiner methodsFor: 'private'!
addSubclasses: aClass to: aList
	| subclassSet index hasBranches hasLeaves newSize newList |
	aClass == Class ifTrue: [ ^aList ].
	subclassSet _ aClass subclasses.
	(subclassSet size) = 0 ifTrue: [ ^aList ].
	aList == nil
		ifTrue: [ index _ 0 ]
		ifFalse: [ index _ (aList size) ].
	hasBranches _ false.
	hasLeaves _ false.
	subclassSet do:
		[ :e | ((e subclasses) size) ~= 0
			ifTrue: [ hasBranches _ true ]
			ifFalse: [ hasLeaves _ true ]].
	newSize _ index + (subclassSet size).
	hasBranches ifTrue: [ newSize _ newSize + 1 ].
	hasLeaves ifTrue: [ newSize _ newSize + 1 ].
	newList _ Array new: newSize.
	1 to: index do: [ :i | newList at: i put: (aList at: i) ].
	hasBranches ifTrue:
		[ newList at: (index _ index + 1) put:
			('--', ((aClass name) asString), '--branches--').
		  subclassSet do:
			[ :e | ((e subclasses) size) ~= 0
				ifTrue: [ newList at: (index _ index + 1)
						put: ((e name) asString) ]]].
	hasLeaves ifTrue:
		[ newList at: (index _ index + 1) put:
			('--', ((aClass name) asString), '--leaves--').
		  subclassSet do:
			[ :e | ((e subclasses) size) = 0
				ifTrue: [ newList at: (index _ index + 1)
						put: ((e name) asString) ]]].
	^ newList
! !

!Examiner methodsFor: 'private'!
lookupSelectorFrom: aClass
	| selector scanner result |
	FillInTheBlank
		request: 'Method to look up:'
		displayAt: Sensor cursorPoint
		centered: true
		action: [ :answer | selector _ answer asSymbol ]
		initialAnswer: 'lookup chain'.
	scanner _ aClass.
	result _ WriteStream on: (String new: 1000).
	result print: selector; cr.
	[ scanner ~~ nil ] whileTrue:
		[ result tab; print: scanner; space.
	  	  (scanner includesSelector: selector)
			ifTrue: [ result nextPut: $+ ]
			ifFalse: [ result nextPut: $- ].
		  result cr.
		  scanner _ scanner superclass ].
	Transcript cr; show: (result contents); cr.
! !



StandardSystemView subclass: #ExaminerView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Interface-Browser'!

!ExaminerView class methodsFor: 'instance creation'!
openOn: aClass withDepth: numberOfWindows
	| topView anExaminer width |
	width _ 1.0 / numberOfWindows.
	anExaminer _ Examiner new on: aClass to: numberOfWindows.
	topView _ self
		model: anExaminer
		label: ((aClass name) asString), ' Examiner'
		minimumSize: (100*numberOfWindows@200).
	1 <= numberOfWindows ifTrue:
		[ topView addLevel1View: (0@0 extent: width@1.0)
			on: anExaminer ].
	2 <= numberOfWindows ifTrue:
		[ topView addLevel2View: (width@0 extent: width@1.0)
			on: anExaminer ].
	3 <= numberOfWindows ifTrue:
		[ topView addLevel3View: (width*2@0 extent: width@1.0)
			on: anExaminer ].
	4 <= numberOfWindows ifTrue:
		[ topView addLevel4View: (width*3@0 extent: width@1.0)
			on: anExaminer ].
	5 <= numberOfWindows ifTrue:
		[ topView addLevel5View: (width*4@0 extent: width@1.0)
			on: anExaminer ].
	6 <= numberOfWindows ifTrue:
		[ topView addLevel6View: (width*5@0 extent: width@1.0)
			on: anExaminer ].
	7 <= numberOfWindows ifTrue:
		[ topView addLevel7View: (width*6@0 extent: width@1.0)
			on: anExaminer ].
	8 <= numberOfWindows ifTrue:
		[ topView addLevel8View: (width*7@0 extent: width@1.0)
			on: anExaminer ].
	9 <= numberOfWindows ifTrue:
		[ topView addLevel9View: (width*8@0 extent: width@1.0)
			on: anExaminer ].
	10 <= numberOfWindows ifTrue:
		[ topView addLevel10View: (width*9@0 extent: width@1.0)
			on: anExaminer ].
	topView controller open.
! !

!ExaminerView methodsFor: 'subview creation'!
addLevel1View: area on: anExaminer
	self addSubView:
		(SelectionInListView on: anExaminer
			printItems: false oneItem: false
			aspect: #level1Name change: #level1Name:
			list: #level1List menu: #level1Menu
			initialSelection: #level1Name)
		in: area borderWidth: 1.
! !

!ExaminerView methodsFor: 'subview creation'!
addLevel2View: area on: anExaminer
	self addSubView:
		(SelectionInListView on: anExaminer
			printItems: false oneItem: false
			aspect: #level2Name change: #level2Name:
			list: #level2List menu: #level2Menu
			initialSelection: #level2Name)
		in: area borderWidth: 1.
! !

!ExaminerView methodsFor: 'subview creation'!
addLevel3View: area on: anExaminer
	self addSubView:
		(SelectionInListView on: anExaminer
			printItems: false oneItem: false
			aspect: #level3Name change: #level3Name:
			list: #level3List menu: #level3Menu
			initialSelection: #level3Name)
		in: area borderWidth: 1.
! !

!ExaminerView methodsFor: 'subview creation'!
addLevel4View: area on: anExaminer
	self addSubView:
		(SelectionInListView on: anExaminer
			printItems: false oneItem: false
			aspect: #level4Name change: #level4Name:
			list: #level4List menu: #level4Menu
			initialSelection: #level4Name)
		in: area borderWidth: 1.
! !

!ExaminerView methodsFor: 'subview creation'!
addLevel5View: area on: anExaminer
	self addSubView:
		(SelectionInListView on: anExaminer
			printItems: false oneItem: false
			aspect: #level5Name change: #level5Name:
			list: #level5List menu: #level5Menu
			initialSelection: #level5Name)
		in: area borderWidth: 1.
! !

!ExaminerView methodsFor: 'subview creation'!
addLevel6View: area on: anExaminer
	self addSubView:
		(SelectionInListView on: anExaminer
			printItems: false oneItem: false
			aspect: #level6Name change: #level6Name:
			list: #level6List menu: #level6Menu
			initialSelection: #level6Name)
		in: area borderWidth: 1.
! !

!ExaminerView methodsFor: 'subview creation'!
addLevel7View: area on: anExaminer
	self addSubView:
		(SelectionInListView on: anExaminer
			printItems: false oneItem: false
			aspect: #level7Name change: #level7Name:
			list: #level7List menu: #level7Menu
			initialSelection: #level7Name)
		in: area borderWidth: 1.
! !

!ExaminerView methodsFor: 'subview creation'!
addLevel8View: area on: anExaminer
	self addSubView:
		(SelectionInListView on: anExaminer
			printItems: false oneItem: false
			aspect: #level8Name change: #level8Name:
			list: #level8List menu: #level8Menu
			initialSelection: #level8Name)
		in: area borderWidth: 1.
! !

!ExaminerView methodsFor: 'subview creation'!
addLevel9View: area on: anExaminer
	self addSubView:
		(SelectionInListView on: anExaminer
			printItems: false oneItem: false
			aspect: #level9Name change: #level9Name:
			list: #level9List menu: #level9Menu
			initialSelection: #level9Name)
		in: area borderWidth: 1.
! !

!ExaminerView methodsFor: 'subview creation'!
addLevel10View: area on: anExaminer
	self addSubView:
		(SelectionInListView on: anExaminer
			printItems: false oneItem: false
			aspect: #level10Name change: #level10Name:
			list: #level10List menu: #level10Menu
			initialSelection: #level10Name)
		in: area borderWidth: 1.
! !



!ScreenController methodsFor: 'menu messages'!
openExaminer
	| examinerClass examinerDepth |
	FillInTheBlank
		request: 'Class to examine:'
		displayAt: Sensor cursorPoint
		centered: true
		action: [ :answer | examinerClass _
				Smalltalk at: (answer asSymbol) ]
		initialAnswer: 'Object'.
	((examinerClass subclasses) size) = 0 ifTrue:
		[ examinerClass _ examinerClass superclass ].
	FillInTheBlank
		request: 'Depth to examine:'
		displayAt: Sensor cursorPoint
		centered: true
		action: [ :answer | examinerDepth _ (answer asNumber) ]
		initialAnswer: '7'.
	examinerDepth < 2 ifTrue: [ examinerDepth _ 2 ].
	examinerDepth > 10 ifTrue: [ examinerDepth _ 10 ].
	ExaminerView openOn: examinerClass withDepth: examinerDepth.
! !

!ScreenController class methodsFor: 'class initialization'!
initialize
	ScreenYellowButtonMenu _
		PopUpMenu
			labels: 
'restore display
exit project
open project
file list
browse
navigate
examine
open workspace
system transcript
system workspace
save
quit'
			lines: #(3 10).
	ScreenYellowButtonMessages _
			#(restoreDisplay exitProject openProject 
			openFileList openBrowser openNavigator openExaminer openWorkspace openTranscript openSystemWorkspace
			save quit).
	ScreenController allInstancesDo: [:c | c initializeYellowButtonMenu].
! !

ScreenController initialize!
