!SequenceableCollection methodsFor: 'copying'!

largerCopy
	"Make a bigger copy of the receiver.  Factored out of grow so higher levels can avoid grow."

	| newArray |
	newArray _ self species new: self size + self growSize.
	^newArray replaceFrom: 1 to: self size with: self! !

!SequenceableCollection methodsFor: 'adding'!

grow
	"The receiver becomes bigger--this is not a copy of the receiver, so all shared references survive."

	^self become: self largerCopy! !

!Paragraph methodsFor: 'private'!

lineAt: indexInteger put: aTextLineInterval 
	"store a line, track last, and grow lines if necessary"

	indexInteger > lastLine ifTrue: [lastLine _ indexInteger].
	lastLine > lines size ifTrue: [lines _  lines largerCopy].
	^lines at: indexInteger put: aTextLineInterval! !
