!Date class methodsFor: 'instance creation'!
fromDays: dayCount
	"Answer an instance of me that is dayCount days after Jan 1 1970.
	Modified for Unix 8/3/83 D. Ungar."
	^self
		newDay: 1 + (dayCount truncated rem: 1461)
							"There are 1461 days in a 4-year cycle. 
							 2000 is a leap year, so no extra correction is necessary. "
		year: 1970 + ((dayCount truncated quo: 1461) * 4)! !

!Date methodsFor: 'converting'!
asSeconds
	"Answer the seconds between a time on1 January 1970 and the same time
	in the receiver's day.
	Modified for Unix 8/3/83 by D. Ungar."

	^SecondsInDay * (self subtractDate: (Date newDay: 1 year: 1970))! !

Smalltalk noChanges.!
