'From Smalltalk-80, version 2, of April 1, 1983 on 9 April 1984 at 3:03:25 am'!

Form subclass: #Wallpaper
	instanceVariableNames: ''
	classVariableNames: 'DefaultFileName Depth NumberOfDummyFields RasterMagic '
	poolDictionaries: ''
	category: 'Graphics-Display Objects'!
Wallpaper comment:
'I let you dump the Display Bitmap into a Suncore compatible raster file for plotting on devices like the Varian or Versatec.  Executing

	Wallpaper dump

will create a file called wallpaper which can be later plotted by the Unix command 

	tprint wallpaper'!


!Wallpaper methodsFor: 'filing out'!

dumpTo: fileName
	"Saves the receiver on the fileName.  Format is compatible with Sun2's /usr/include/rasterfile.h format.  Unix wants 32-bit words, but a bitmap in Smalltalk is 16 bit."
	| file filePosition screenRect screenForm w h b |
	file _ FileStream fileNamed: fileName.
	file binary.
	Cursor read showWhile: [screenForm _ self computeDisplayForm].
	w _ screenForm width.
	h _ screenForm height.
	b _ screenForm bits.
	file nextWordPut: (RasterMagic at: 1); nextWordPut: (RasterMagic at: 2 ).
	file nextWordPut: 0; nextWordPut: w.
	file nextWordPut: 0; nextWordPut: h.
	file nextWordPut: 0; nextWordPut: Depth.
	NumberOfDummyFields timesRepeat: [file nextWordPut: 0].	"other dummy fields"
	filePosition _ 0.
	Cursor write showWhile: [1 to: w + 15 // 16 do:
		[:j |
		1 to: h do: [:i | file nextWordPut: (b at: (filePosition _ filePosition + 1))]]].
	file close.! !

!Wallpaper methodsFor: 'screen access'!

computeDisplayForm
	"returns a form of the Display"
	^Form fromDisplay: (DisplayScreen boundingBox)! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Wallpaper class
	instanceVariableNames: ''!


!Wallpaper class methodsFor: 'initialization'!

initialize
	"initializes several magic numbers"

	RasterMagic _ WordArray with: 8r054646 with: 8r065225.
	NumberOfDummyFields _ 8.
	Depth _ 1.
	DefaultFileName _ 'wallpaper'

	"Wallpaper initialize"! !

!Wallpaper class methodsFor: 'dumping screen'!

dump
	"dump screen form to a file."
	self dumpTo: DefaultFileName

	"Wallpaper dump"!

dumpTo: fileName
	self new dumpTo: fileName

	"Wallpaper dumpTo: 'wallpaper'"!

wait: numberOfSeconds dumpTo: fileName
	"wait for some time before dumping screen.  It is supposed to fork off a process that waits for some time and then dumps the display.  But it doesn't work."

	[Delay forSeconds: numberOfSeconds.
	self dumpTo: fileName.
	Transcript show: 'Wallpaper completed.'; cr] forkAt: 4

	"Wallpaper wait: 30 dumpTo: 'wallpaper'"! !

Wallpaper initialize!
