static char bitblt_h[] = "$Header: bitblt.h,v 41.3 84/07/25 22:28:49 pkl Exp $";

/*
 *	Copyright (C) 1983 by the Regents of University of California 
 */

/*
 *	Macros for accessing various
 *	fields of an oop to Bitblt, scanCharacters.
 */

# define bitsToBitOffset(x)	((x) & 0xf)	/* bit no. to bits in word */
# define HALFTONE_WORDS		16		/* words in a halftone mask */
# define halftoneOffset(x)	((x) & 0xf)
# define MAX_BIT_FIELD		32		/* largest VAX bit field */
# define wordsToBits(x)		((x) << 4)
# define bitsToWords(x)		((x) / 16)
# define nonNegBitsToWords(x)	((x) >> 4)	/* faster */


/*
 *	These checks the halftone bitmap for potential optimizations.
 *	Bitmap must be 16x16.  ``p'' should be a register int for this
 *	to work (and work fast).  It is faster to use logical-or than
 *	short-circuit or (||).
 */

# define isZerosBitmap(p) \
    (!(*(int *)p  |  ((int *)p)[1]  |  ((int *)p)[2]  |  ((int *)p)[3]\
		  |  ((int *)p)[4]  |  ((int *)p)[5]  |  ((int *)p)[6]\
		  |  ((int *)p)[7]))


# define isOnesBitmap(p) \
    (!(~*(int *)p  |  ~((int *)p)[1]  |  ~((int *)p)[2]  |  ~((int *)p)[3]\
		   |  ~((int *)p)[4]  |  ~((int *)p)[5]  |  ~((int *)p)[6]\
		   |  ~((int *)p)[7]))


# define isOzozBitmap(p) \
    (*(int *)p == 0xaaaa5555  &&  ((int *)p)[1] == 0xaaaa5555 \
    &&  ((int *)p)[2] == 0xaaaa5555  &&  ((int *)p)[3] == 0xaaaa5555\
    &&  ((int *)p)[4] == 0xaaaa5555  &&  ((int *)p)[5] == 0xaaaa5555\
    &&  ((int *)p)[6] == 0xaaaa5555  &&  ((int *)p)[7] == 0xaaaa5555)


# define isZozoBitmap(p) \
    (*(int *)p == 0x5555aaaa  &&  ((int *)p)[1] == 0x5555aaaa \
    &&  ((int *)p)[2] == 0x5555aaaa  &&  ((int *)p)[3] == 0x5555aaaa\
    &&  ((int *)p)[4] == 0x5555aaaa  &&  ((int *)p)[5] == 0x5555aaaa\
    &&  ((int *)p)[6] == 0x5555aaaa  &&  ((int *)p)[7] == 0x5555aaaa)


# define isZzozBitmap(p) \
    (*(int *)p == 0x22228888  &&  ((int *)p)[1] == 0x22228888 \
    &&  ((int *)p)[2] == 0x22228888  &&  ((int *)p)[3] == 0x22228888\
    &&  ((int *)p)[4] == 0x22228888  &&  ((int *)p)[5] == 0x22228888\
    &&  ((int *)p)[6] == 0x22228888  &&  ((int *)p)[7] == 0x22228888)


/*
 *	Field offsets for scanChars
 */

# define resultRp(rp)		(((rp_t *)rp)[0])
# define startIndexRp(rp)	(rp[1])
# define stopIndexRp(rp)	(rp[2])
# define sourceStringRp(rp)	(((rp_t *)rp)[3])
# define rightXRp(rp)		(rp[4])
# define stopsRp(rp)		(((rp_t *)rp)[5])
# define displayRp(rp)		(((rp_t *)rp)[6])


/*
 *	Return value indices ino stopsArg
 */

# define minStopsLength		258
# define crossedXIndex		258
# define stopIndexIndex		257


/*
 *	Stores val into dst.  
 */

# define putInt(val, dst) \
	if (TRUE) {\
		if (!isIntegerValue(val))\
			fatal("can't restore nonInt in scanChars",\
			    (oop_t)(val));\
		dst = integerObjectOf(val);\
	}\
	else


/*
 *	Constants for pixrects functions.  Only needed when
 *	pixrect/pixrect_hs.h is included.
 */

# ifdef PIXRECT_HS
#	define	PIXEL_DEPTH	1
#	define	PIX_COPY	(PIX_SRC | PIX_DONTCLIP)
#	define	PIX_MASK	(PIX_SRC & PIX_DST  |  PIX_DONTCLIP)
#	define	PIX_PAINT	(PIX_SRC | PIX_DST  |  PIX_DONTCLIP)
#	define	PIX_ERASE	(PIX_NOT(PIX_SRC) & PIX_DST  |  PIX_DONTCLIP)
#	define	PIX_BLACK	PIX_COLOR(1)
#	define	PIX_WHITE	PIX_COLOR(0)
# endif
