static char rcsId[] = "$Header: execBlock.c,v 43.1 84/04/05 23:51:52 dmu Exp $";

/*
 *	Copyright (C) 1983 by the Regents of University of California 
 *	All Rights Reserved.
 */

/*
 *	bytecode interpreter for executing blocks
 *
 *	See executeBlock.h for most of the real code.
 */

# include	<stdio.h>

# include	"utils.h"
# include	"mem.h"
# include	"prims.h"
# include	"execute.h"
# include	"execBlock.h"


/*
 *	This is the byte code interpreter for block contexts.
 *	Structurally, it is similar to executeMethod.  The major
 *	difference lies in the definition of the macros.
 */

rp_t
executeBlock(ac)
oop_t ac;			/* not enough registers */
{
	register rp_t	hc;	/* home context */
	register byte_t	*pc;	/* address of next bytecode */
	register oop_t	*sp;	/* for efficiency: push is *sp++, pop *--sp */
	register rp_t	method;

	register oop_t	rcvr;
	register oop_t	r1;	/* scratch */
	register oop_t	r2;	/* scratch */
	/* plus one for ggcStore */

	extern rp_t	CBlockCopyPrm();


	fetchLocals((rp_t)(ac));
	for (;;) {		/* loop forever */
		assert(isBlock((rp_t)ac), "executeBlock: ac is not a block");
		if (!checkBreakpoint()  ||  !checkDbTrace(pc, sp)) {
			storeLocals((rp_t)ac);
			return ((rp_t)ac);
		}
#		ifdef CYCLE
			++cycle;
#		endif
		asm("# SWITCH");
		switch (*pc++) {


		/*
		 *	pushes  
		 */

		pushRcvrVar(0, 0, _BpushRcvrVar0);
		pushRcvrVar(1, 1, _BpushRcvrVar1);
		pushRcvrVar(2, 2, _BpushRcvrVar2);
		pushRcvrVar(3, 3, _BpushRcvrVar3);
		pushRcvrVar(4, 4, _BpushRcvrVar4);
		pushRcvrVar(5, 5, _BpushRcvrVar5);
		pushRcvrVar(6, 6, _BpushRcvrVar6);
		pushRcvrVar(7, 7, _BpushRcvrVar7);
		pushRcvrVar(8, 8, _BpushRcvrVar8);
		pushRcvrVar(9, 9, _BpushRcvrVar9);
		pushRcvrVar(10, 10, _BpushRcvrVar10);
		pushRcvrVar(11, 11, _BpushRcvrVar11);
		pushRcvrVar(12, 12, _BpushRcvrVar12);
		pushRcvrVar(13, 13, _BpushRcvrVar13);
		pushRcvrVar(14, 14, _BpushRcvrVar14);
		pushRcvrVar(15, 15, _BpushRcvrVar15);

		pushTempVar(16 + 0,  0,  _BpushTempVar0);
		pushTempVar(16 + 1,  1,  _BpushTempVar1);
		pushTempVar(16 + 2,  2,  _BpushTempVar2);
		pushTempVar(16 + 3,  3,  _BpushTempVar3);
		pushTempVar(16 + 4,  4,  _BpushTempVar4);
		pushTempVar(16 + 5,  5,  _BpushTempVar5);
		pushTempVar(16 + 6,  6,  _BpushTempVar6);
		pushTempVar(16 + 7,  7,  _BpushTempVar7);
		pushTempVar(16 + 8,  8,  _BpushTempVar8);
		pushTempVar(16 + 9,  9,  _BpushTempVar9);
		pushTempVar(16 + 10,  10,  _BpushTempVar10);
		pushTempVar(16 + 11,  11,  _BpushTempVar11);
		pushTempVar(16 + 12,  12,  _BpushTempVar12);
		pushTempVar(16 + 13,  13,  _BpushTempVar13);
		pushTempVar(16 + 14,  14,  _BpushTempVar14);
		pushTempVar(16 + 15,  15,  _BpushTempVar15);

		pushLitConst(32 + 0,  0,  _BpushLitConst0);
		pushLitConst(32 + 1,  1,  _BpushLitConst1);
		pushLitConst(32 + 2,  2,  _BpushLitConst2);
		pushLitConst(32 + 3,  3,  _BpushLitConst3);
		pushLitConst(32 + 4,  4,  _BpushLitConst4);
		pushLitConst(32 + 5,  5,  _BpushLitConst5);
		pushLitConst(32 + 6,  6,  _BpushLitConst6);
		pushLitConst(32 + 7,  7,  _BpushLitConst7);
		pushLitConst(32 + 8,  8,  _BpushLitConst8);
		pushLitConst(32 + 9,  9,  _BpushLitConst9);
		pushLitConst(32 + 10,  10,  _BpushLitConst10);
		pushLitConst(32 + 11,  11,  _BpushLitConst11);
		pushLitConst(32 + 12,  12,  _BpushLitConst12);
		pushLitConst(32 + 13,  13,  _BpushLitConst13);
		pushLitConst(32 + 14,  14,  _BpushLitConst14);
		pushLitConst(32 + 15,  15,  _BpushLitConst15);
		pushLitConst(32 + 16,  16,  _BpushLitConst16);
		pushLitConst(32 + 17,  17,  _BpushLitConst17);
		pushLitConst(32 + 18,  18,  _BpushLitConst18);
		pushLitConst(32 + 19,  19,  _BpushLitConst19);
		pushLitConst(32 + 20,  20,  _BpushLitConst20);
		pushLitConst(32 + 21,  21,  _BpushLitConst21);
		pushLitConst(32 + 22,  22,  _BpushLitConst22);
		pushLitConst(32 + 23,  23,  _BpushLitConst23);
		pushLitConst(32 + 24,  24,  _BpushLitConst24);
		pushLitConst(32 + 25,  25,  _BpushLitConst25);
		pushLitConst(32 + 26,  26,  _BpushLitConst26);
		pushLitConst(32 + 27,  27,  _BpushLitConst27);
		pushLitConst(32 + 28,  28,  _BpushLitConst28);
		pushLitConst(32 + 29,  29,  _BpushLitConst29);
		pushLitConst(32 + 30,  30,  _BpushLitConst30);
		pushLitConst(32 + 31,  31,  _BpushLitConst31);

		pushLitVar(64 + 0,  0,  _BpushLitVar0);
		pushLitVar(64 + 1,  1,  _BpushLitVar1);
		pushLitVar(64 + 2,  2,  _BpushLitVar2);
		pushLitVar(64 + 3,  3,  _BpushLitVar3);
		pushLitVar(64 + 4,  4,  _BpushLitVar4);
		pushLitVar(64 + 5,  5,  _BpushLitVar5);
		pushLitVar(64 + 6,  6,  _BpushLitVar6);
		pushLitVar(64 + 7,  7,  _BpushLitVar7);
		pushLitVar(64 + 8,  8,  _BpushLitVar8);
		pushLitVar(64 + 9,  9,  _BpushLitVar9);
		pushLitVar(64 + 10,  10,  _BpushLitVar10);
		pushLitVar(64 + 11,  11,  _BpushLitVar11);
		pushLitVar(64 + 12,  12,  _BpushLitVar12);
		pushLitVar(64 + 13,  13,  _BpushLitVar13);
		pushLitVar(64 + 14,  14,  _BpushLitVar14);
		pushLitVar(64 + 15,  15,  _BpushLitVar15);
		pushLitVar(64 + 16,  16,  _BpushLitVar16);
		pushLitVar(64 + 17,  17,  _BpushLitVar17);
		pushLitVar(64 + 18,  18,  _BpushLitVar18);
		pushLitVar(64 + 19,  19,  _BpushLitVar19);
		pushLitVar(64 + 20,  20,  _BpushLitVar20);
		pushLitVar(64 + 21,  21,  _BpushLitVar21);
		pushLitVar(64 + 22,  22,  _BpushLitVar22);
		pushLitVar(64 + 23,  23,  _BpushLitVar23);
		pushLitVar(64 + 24,  24,  _BpushLitVar24);
		pushLitVar(64 + 25,  25,  _BpushLitVar25);
		pushLitVar(64 + 26,  26,  _BpushLitVar26);
		pushLitVar(64 + 27,  27,  _BpushLitVar27);
		pushLitVar(64 + 28,  28,  _BpushLitVar28);
		pushLitVar(64 + 29,  29,  _BpushLitVar29);
		pushLitVar(64 + 30,  30,  _BpushLitVar30);
		pushLitVar(64 + 31,  31,  _BpushLitVar31);

		pushConstObj(113, (oop_t)trueOop, _BpushTrue);
		pushConstObj(114, (oop_t)falseOop, _BpushFalse);
		pushConstObj(115, (oop_t)nilOop, _BpushNil);
		pushConstObj(116, integerObjectOf(-1), _BpushMinOne);
		pushConstObj(117, integerObjectOf(0), _BpushZero);
		pushConstObj(118, integerObjectOf(1), _BpushOne);
		pushConstObj(119, integerObjectOf(2), _BpushTwo);

		case 112:	/* push rcvr */
			adb(_BpushRcvr);
			*sp++ = rcvr;
			break;

		case 136: 	/* dup stack top */
			adb(_BdupStackTop);
			*sp = sp[-1];
			++sp;
			break;

		case 137:	 /* push active context */
			adb(_BpushActiveContext);
			*sp++ = ac;
			break;

		case 128:	/* extended push */
			adb(_BextendedPush);
			r2 = *pc++;
			switch (r2 >> 6  &  0x3) {
			case 0:	/* receiver var */
				*sp++ = oopFieldRp((rp_t)rcvr)[r2 & 0x3f];
				break;
			case 1: /* temporary var */
				*sp++ = tempFrameC(hc)[r2 & 0x3f];
				break;
			case 2: /* literal const */
				*sp++ = literalFrameCM(method)[r2 & 0x3f];
				break;
			case 3:	/* literal var */
				*sp++ = valueAs((rp_t)literalFrameCM(method)[
					r2 & 0x3f]);
				break;
			default:
				fatal("illegal extended push", NullOop);
				break;
			}
			break;

		/*
		 *	end of pushes
		 */

		/*
		 *	pops
		 */

		storePopRcvrVar(96 + 0, 0, _BstorePopRcvrVar0);
		storePopRcvrVar(96 + 1, 1, _BstorePopRcvrVar1);
		storePopRcvrVar(96 + 2, 2, _BstorePopRcvrVar2);
		storePopRcvrVar(96 + 3, 3, _BstorePopRcvrVar3);
		storePopRcvrVar(96 + 4, 4, _BstorePopRcvrVar4);
		storePopRcvrVar(96 + 5, 5, _BstorePopRcvrVar5);
		storePopRcvrVar(96 + 6, 6, _BstorePopRcvrVar6);
		storePopRcvrVar(96 + 7, 7, _BstorePopRcvrVar7);

		storePopTempVar(104 + 0, 0, _BstorePopTempVar0);
		storePopTempVar(104 + 1, 1, _BstorePopTempVar1);
		storePopTempVar(104 + 2, 2, _BstorePopTempVar2);
		storePopTempVar(104 + 3, 3, _BstorePopTempVar3);
		storePopTempVar(104 + 4, 4, _BstorePopTempVar4);
		storePopTempVar(104 + 5, 5, _BstorePopTempVar5);
		storePopTempVar(104 + 6, 6, _BstorePopTempVar6);
		storePopTempVar(104 + 7, 7, _BstorePopTempVar7);

		case 135:	/* pop stack top */
			adb(_BpopStackTop);
			--sp;
			break;

		/*
		 *	See storePop macro in executeBlock.h for
		 *	ggcStore discussion.
		 */

		case 130:	/* extended store pop */
			adb(_BextendedStorePop);
			r2 = *pc++;
			switch (r2 >> 6  &  0x3) {
			case 0:	/* receiver var */
				r1 = *--sp;
				oopFieldRp((rp_t)rcvr)[r2 & 0x3f] = r1;
				ggcStore((rp_t)rcvr, r1);
				break;
			case 1: /* temp var */
				r1 = *--sp;
				tempFrameC(hc)[r2 & 0x3f] = r1;
				ggcStore(hc, r1);
				break;

			/*
			 *	case 2 is illegal (by definition)
			 */

			case 3:	/* lit var */
				r1 = literalFrameCM(method)[r2 & 0x3f];
				valueAs((rp_t)r1) = *--sp;
				ggcStore((rp_t)r1, *sp);
				break;
			default:
				fatal("illegal extended store and pop", NullOop);
				break;
			}
			break;

		/*
		 *	end of pops
		 */

		/*
		 *	stores
		 */
		case 129:	/* extended store */
			adb(_BextendedStore);
			r2 = *pc++;
			switch (r2 >> 6  &  0x3) {
			default:
				fatal("illegal bytecode in MC", (oop_t)ac);
			case 0:	/* receiver var */ 
				r1 = sp[-1];
				oopFieldRp((rp_t)rcvr)[r2 & 0x3f] =  r1;
				ggcStore((rp_t)rcvr, r1);
				break;
			case 1: /* temporary var */
				r1 = sp[-1];
				tempFrameC(hc)[r2 & 0x3f] = r1;
				ggcStore(hc, r1);
				break;

			/*
			 *	case 2 is illegal (by definition).
			 */

			case 3:	/* literal var */
				r1 = literalFrameCM(method)[r2 & 0x3f];
				valueAs((rp_t)r1) = sp[-1];
				ggcStore((rp_t)r1, sp[-1]);
				break;
			}
			break;
		/*
		 *	end of stores
		 */

		/*
		 *	jumps
		 */

		jump(144, 1, _Bjump1); jump(145, 2, _Bjump2); 
		jump(146, 3, _Bjump3); jump(147, 4, _Bjump4); 
		jump(148, 5, _Bjump5); jump(149, 6, _Bjump6);
		jump(150, 7, _Bjump7); jump(151, 8, _Bjump8);

		popJump(152, 1, falseOop, trueOop, _BpopJump1);
		popJump(153, 2, falseOop, trueOop, _BpopJump2);
		popJump(154, 3, falseOop, trueOop, _BpopJump3);
		popJump(155, 4, falseOop, trueOop, _BpopJump4);
		popJump(156, 5, falseOop, trueOop, _BpopJump5);
		popJump(157, 6, falseOop, trueOop, _BpopJump6);
		popJump(158, 7, falseOop, trueOop, _BpopJump7);
		popJump(159, 8, falseOop, trueOop, _BpopJump8);

		extendedJump(160, 0, _BextendedJump0);
		extendedJump(161, 1, _BextendedJump1);
		extendedJump(162, 2, _BextendedJump2);
		extendedJump(163, 3, _BextendedJump3);
		extendedJump(164, 4, _BextendedJump4);
		extendedJump(165, 5, _BextendedJump5);
		extendedJump(166, 6, _BextendedJump6);
		extendedJump(167, 7, _BextendedJump7);

		extendedPopJump(168, 0, trueOop, falseOop, _BextendedPopJumpT0);
		extendedPopJump(169, 1, trueOop, falseOop, _BextendedPopJumpT1);
		extendedPopJump(170, 2, trueOop, falseOop, _BextendedPopJumpT2);
		extendedPopJump(171, 3, trueOop, falseOop, _BextendedPopJumpT3);

		extendedPopJump(172, 0, falseOop, trueOop, _BextendedPopJumpF0);
		extendedPopJump(173, 1, falseOop, trueOop, _BextendedPopJumpF1);
		extendedPopJump(174, 2, falseOop, trueOop, _BextendedPopJumpF2);
		extendedPopJump(175, 3, falseOop, trueOop, _BextendedPopJumpF3);

		/*
		 *	end of jumps
		 */

		/*
		 *	sends.
		 */

		sendLitSel(208 + 0,  0,  0,  _BsendLitSel0_0);
		sendLitSel(208 + 1,  1,  0,  _BsendLitSel1_0);
		sendLitSel(208 + 2,  2,  0,  _BsendLitSel2_0);
		sendLitSel(208 + 3,  3,  0,  _BsendLitSel3_0);
		sendLitSel(208 + 4,  4,  0,  _BsendLitSel4_0);
		sendLitSel(208 + 5,  5,  0,  _BsendLitSel5_0);
		sendLitSel(208 + 6,  6,  0,  _BsendLitSel6_0);
		sendLitSel(208 + 7,  7,  0,  _BsendLitSel7_0);
		sendLitSel(208 + 8,  8,  0,  _BsendLitSel8_0);
		sendLitSel(208 + 9,  9,  0,  _BsendLitSel9_0);
		sendLitSel(208 + 10,  10,  0,  _BsendLitSel10_0);
		sendLitSel(208 + 11,  11,  0,  _BsendLitSel11_0);
		sendLitSel(208 + 12,  12,  0,  _BsendLitSel12_0);
		sendLitSel(208 + 13,  13,  0,  _BsendLitSel13_0);
		sendLitSel(208 + 14,  14,  0,  _BsendLitSel14_0);
		sendLitSel(208 + 15,  15,  0,  _BsendLitSel15_0);

		sendLitSel(224 + 0,  0,  1,  _BsendLitSel0_1);
		sendLitSel(224 + 1,  1,  1,  _BsendLitSel1_1);
		sendLitSel(224 + 2,  2,  1,  _BsendLitSel2_1);
		sendLitSel(224 + 3,  3,  1,  _BsendLitSel3_1);
		sendLitSel(224 + 4,  4,  1,  _BsendLitSel4_1);
		sendLitSel(224 + 5,  5,  1,  _BsendLitSel5_1);
		sendLitSel(224 + 6,  6,  1,  _BsendLitSel6_1);
		sendLitSel(224 + 7,  7,  1,  _BsendLitSel7_1);
		sendLitSel(224 + 8,  8,  1,  _BsendLitSel8_1);
		sendLitSel(224 + 9,  9,  1,  _BsendLitSel9_1);
		sendLitSel(224 + 10,  10,  1,  _BsendLitSel10_1);
		sendLitSel(224 + 11,  11,  1,  _BsendLitSel11_1);
		sendLitSel(224 + 12,  12,  1,  _BsendLitSel12_1);
		sendLitSel(224 + 13,  13,  1,  _BsendLitSel13_1);
		sendLitSel(224 + 14,  14,  1,  _BsendLitSel14_1);
		sendLitSel(224 + 15,  15,  1,  _BsendLitSel15_1);

		sendLitSel(240 + 0,  0,  2,  _BsendLitSel0_2);
		sendLitSel(240 + 1,  1,  2,  _BsendLitSel1_2);
		sendLitSel(240 + 2,  2,  2,  _BsendLitSel2_2);
		sendLitSel(240 + 3,  3,  2,  _BsendLitSel3_2);
		sendLitSel(240 + 4,  4,  2,  _BsendLitSel4_2);
		sendLitSel(240 + 5,  5,  2,  _BsendLitSel5_2);
		sendLitSel(240 + 6,  6,  2,  _BsendLitSel6_2);
		sendLitSel(240 + 7,  7,  2,  _BsendLitSel7_2);
		sendLitSel(240 + 8,  8,  2,  _BsendLitSel8_2);
		sendLitSel(240 + 9,  9,  2,  _BsendLitSel9_2);
		sendLitSel(240 + 10,  10,  2,  _BsendLitSel10_2);
		sendLitSel(240 + 11,  11,  2,  _BsendLitSel11_2);
		sendLitSel(240 + 12,  12,  2,  _BsendLitSel12_2);
		sendLitSel(240 + 13,  13,  2,  _BsendLitSel13_2);
		sendLitSel(240 + 14,  14,  2,  _BsendLitSel14_2);
		sendLitSel(240 + 15,  15,  2,  _BsendLitSel15_2);

		case 131:	/* send literal selector #kkkkk with jjj args */
			adb(_BsendLitSeljjjkkkkk);
			r1 = *pc++;
			doASend(literalFrameCM(method)[r1 & 0x1f], r1 >> 5);

		case 133:	/* send lit sel #kkkkk to super with jjj args */
			adb(_BsendLitSelSupjjjkkkkk);
			r1 = *pc++;
			doASuperSend(literalFrameCM(method)[r1 & 0x1f],
			    r1 >> 5);

		case 132:	/* send lit sel #k8 with j8 args */
			adb(_BsendLitSelj8k8);
			r2 = *pc++;
			r1 = *pc++;
			doASend(literalFrameCM(method)[r1], r2);

		case 134:	/* send lit sel k8 to super with j8 args */
			adb(_BsendLitSelSupj8k8);
			r2 = *pc++;
			r1 = *pc++;
			doASuperSend(literalFrameCM(method)[r1], r2);

		/*
	 	 *	Here are the direct primitives.  They are also 
		 *	implemented in *Prims.c.  The code is not factored 
		 *	because there are slight differences.  This is 
		 *	speed-critical code.  Since there is no lookup 
		 *	involved the direct primitives must check the 
		 *	class of the receiver.
		 *
		 *	The "magic" number in DirectRATest(), 
		 *	DirectOperationFinish(), ... is the offset of 
		 *	the selector in the object pointed to by
		 *	SpecialSelectorsOop.  It is calculated by
		 *	(bytecode - 176) * 2.
		 */
	
		case 176:	/* send + */
			adb(_BsendPlus);
			DirectRATest(0);
			DirectRAConvert;
			r1 += r2;
			DirectOperationFinish(0);
	
		case 177:	/* send - */
			adb(_BsendMinus);
			DirectRATest(2);
			DirectRAConvert;
			r1 -= r2;
			DirectOperationFinish(2);
	
		case 178:	/* send < */
			adb(_BsendLt);
			DirectRATest(4);
			DirectRAConvert;
			DirectRelationFinish(r1 < r2);
	
		case 179:	/* send > */
			adb(_BsendGt);
			DirectRATest(6);
			DirectRAConvert;
			DirectRelationFinish(r1 > r2);
	
		case 180:	/* send <= */
			adb(_BsendLe);
			DirectRATest(8);
			DirectRAConvert;
			DirectRelationFinish(r1 <= r2);
	
		case 181:	/* send >= */
			adb(_BsendGe);
			DirectRATest(10);
			DirectRAConvert;
			DirectRelationFinish(r1 >= r2);
	
		case 182:	/* send = */
			adb(_BsendEq);
			DirectRATest(12);
			DirectRelationFinish(r1 == r2);
	
		case 183:	/* send ~= */
			adb(_BsendNeq);
			DirectRATest(14);
			DirectRelationFinish(r1 != r2);
	
		case 184:	/* send *, -2**31 <= r1,r2 < 2**31 must hold */
			adb(_BsendTimes);
			DirectRATest(16);
			DirectRAConvert;
			if (r1 >= 0x7fff  ||  r1 < -0x7fff
			    ||  r2 >= 0x7fff  ||  r2 < -0x7fff)
				DirectRARecover(16);
			r1 = (short)r1 * (short)r2;
			DirectOperationFinish(16);
	
		case 185:	/* send /,  result must be exact */
			adb(_BsendSlash);
			DirectRATest(18);
			DirectRAConvert;
			if (r2 == 0  ||  r1 % r2  !=  0)
				DirectRARecover(18);
			r1 /= r2;
			DirectOperationFinish(18);
	
		/*
		 *	send \\ (modulus),
		 *	quotient always rounded down towards - infinity
		 *	See SIModPrm() for a description about the funny
		 *	% business.
		 */

		case 186:
			adb(_BsendMod);
			DirectRATest(20);
			DirectRAConvert;
			if (r2 == 0)
				DirectRARecover(20);
			if (r1 >= 0  &&  r2 > 0)
				r1 %= r2;
			else if (r1 >= 0) {
				r2 = -r2;
				r1 %= r2; 	/* but 3 mod -4 is 3-4=-1 */
				if (r1)
					r1 -= r2;
			}
			else if (r2 > 0) {
				r1 = -r1;
				r1 %= r2;	/* but -3 mod 4 is -3--4 is 1 */
				if (r1)
					r1 = r2 - r1;
			}
			else {
				r1 = -r1;
				r2 = -r2;
				r1 %= r2;	/* -3 mod -4 is -3 - 0 is -3 */
				if (r1)
					r1 = -r1;
			}
			DirectOperationFinish(20);
	
	
		/*
		 *	do instantiateClass() inline for speed
		 */

		case 187:	/* @ (makePoint) */
			adb(_BsendAt);
			r1 = (oop_t)method;	/* steal method */

			allocAnObj(&New, pointLength, method);
			classRp(method) = classPointOop;
			lengthRp(method) = pointLength;
			flagsRp(method) = 0;
			ageRp(method) = 0;
			formatRp(method) = OOPS;
			fixedFieldsRp(method) = pointLength;
			if (!isIntegerValue(NewHash))
				NewHash = lastRegXoop + 1;
			hashRp(method) = integerObjectOf(NewHash);

			yPt(method) = *--sp;
			ggcStore(method, *sp);
			xPt(method) = *--sp;
			ggcStore(method, *sp);
			*sp++ = (oop_t)method;

			method = (rp_t)r1;
			break;
	
		case 188:	/* send bitShift: arith shift left */
			adb(_BsendLsh);
			DirectRATest(24);
			DirectRAConvert;
			if (r2 < 0)
				r1 >>= -r2;
			else
				r1 <<= r2;
			DirectOperationFinishWithOverflow(24, BAslOvfl);
	
		/*
		 *	send // (divide),
		 *	quotient always rounded down towards negative infinity
		 */

		case 189:
			adb(_BsendSlsl);
			DirectRATest(26);
			DirectRAConvert;
			if (r2 == 0)
				DirectRARecover(26);
			if ((r1 ^ r2) < 0  &&  r1 % r2)
				r1 = r1 / r2  -  1;
			else
				r1 /= r2;
			DirectOperationFinish(26);
	
		case 190:	/* bitAnd: */
			adb(_BsendAnd);
			DirectRATest(28);
			DirectRAEnd(r1 & r2);
			break;
	
		case 191:	/* bitOr: */
			adb(_BsendOr);
			DirectRATest(30);
			DirectRAEnd(r1 | r2);
			break;
	
		/*
		 *	next three cheat for speed
		 */
	
		case 192:	/* at: */
			adb(_BsendAtCol);
			r1 = (oop_t)method;	/* steal method */
			method = (rp_t)sp[-2];
			r2 = sp[-1];
			if (!isIntegerObject((oop_t)method) 
			    &&  fixedFieldsRp(method) == 0  
			    &&  formatRp(method) == OOPS
			    &&  isIntegerObject(r2)) {
				r2 = nonNegIntegerValueOf(r2) - 1;
				if ((u_int)r2 < (u_int)lengthRp(method)) {
					sp[-2] = oopFieldRp(method)[r2];
					--sp;
					method = (rp_t)r1;/* restore method */
					break;	/* next bytecode */
				}
			}
			method = (rp_t)r1;/* restore method */
			doASend(specialSelOf(32), specialNargOf(32));

		case 193:	/* at:put: */
			adb(_BsendAtPut);
			method = (rp_t)sp[-3];	/* steal method */
			if (!isIntegerObject((oop_t)method)  
			    &&  fixedFieldsRp(method) == 0
			    &&  formatRp(method) == OOPS) {
				r1 = sp[-2];
				if (isIntegerObject(r1)) {
					r1 = nonNegIntegerValueOf(r1) - 1;
					if ((u_int)r1
					    < (u_int)lengthRp(method)) {
						r2 = *--sp;
						oopFieldRp(method)[r1] = r2;
						sp--;
						sp[-1] = r2;
						ggcStore(method, r2);
						method = methodMC(hc);
						break;
					}
				}
			}
			method = methodMC(hc);
			doASend(specialSelOf(34), specialNargOf(34));

		case 194:	/* size */
			adb(_BsendSize);
			r1 = sp[-1];
			if (!isIntegerObject((oop_t)r1)
			    &&  fixedFieldsRp((rp_t)r1) == 0) {
				sp[-1] = integerObjectOf(lengthRp((rp_t)r1));
				break;
			}
			doASend(specialSelOf(36), specialNargOf(36));

		case 195:	/* next */
			adb(_BsendNext);
			doASend(specialSelOf(38), specialNargOf(38));

		case 196:	/* nextPut: */
			adb(_BsendNextPut);
			doASend(specialSelOf(40), specialNargOf(40));

		case 197:	/* atEnd */
			adb(_BsendAtEnd);
			doASend(specialSelOf(42), specialNargOf(42));
	
		case 198:	/* send == */
			adb(_BsendEqual);
			r1 = *--sp;
			if (*--sp == r1)
				*sp++ = (oop_t)trueOop;
			else
				*sp++ = (oop_t)falseOop;
			break;
	
		case 199:	/* class */
			adb(_BsendClass);
			r1 = *--sp;
			if (isIntegerObject(r1))
				*sp++ = (oop_t)classSmallIntegerOop;
			else
				*sp++ = (oop_t)classRp((rp_t)r1);
			break;
	
		case 200:	/* blockCopy: */
			adb(_BsendBlockCopy);
			r1 = sp[-2];
			if (isIntegerObject(r1))
				doASend(specialSelOf(48), specialNargOf(48));
			if (!(flagsRp((rp_t)r1) & CONTEXT))
				doASend(specialSelOf(48), specialNargOf(48));
			storeLocals((rp_t)ac);
			if (CBlockCopyPrm(sp - 2,  (rp_t)ac) == (rp_t)NullOop)
				doASend(specialSelOf(48), specialNargOf(48));
			--sp;
			break;
	
		case 201:	/* value with zero args */
			adb(_BsendValue0);
			r1 = *--sp;
			storeLocals((rp_t)ac);
			method = (rp_t)r1;	/* steal method */
			if (isIntegerObject(r1)  
			    ||  classRp(method) != classBlockContextOop
			    ||  argCountBC(method)  !=  integerObjectOf(0)
			    ||  callerBC(method) != nilOop) {
				++sp;
				method = methodMC(hc);
				doASend(specialSelOf(50), specialNargOf(50));
			}

			/*
			 *	all is well;  now do it.
			 */

			/*
			 *	maintain caller chain
			 */

			callerBC(method) = (rp_t)ac;
			ipC(method) = initIPBC(method);
			spC(method) = integerObjectOf(0);
			ac = (oop_t)method;
			assert((rp_t)ac != nilOop,  "nil ac in Bvalue");
			assert(FutureSurvivors.sp_bottom > ac 
			    ||  ac >= FutureSurvivors.sp_top,
			    "ac in wrong space");
			if (checkPoll())
				return (method);
			fetchLocals(r1);
			break;
	
		case 202:	/* value: with one args */
			adb(_BsendValue1);
			sp -= 2;
			r1 = *sp;
			storeLocals((rp_t)ac);
			method = (rp_t)r1;	/* steal method */
			if (isIntegerObject(r1)  
			    ||  classRp(method) != classBlockContextOop
			    ||  argCountBC(method)  !=  integerObjectOf(1)
			    ||  callerBC(method) != nilOop) {
				sp += 2;
				method = methodMC(hc);
				doASend(specialSelOf(52), specialNargOf(52));
			}

			/*
			 *	all is well;  now do it.
			 */

			tempFrameC(method)[0] = sp[1];

			/*
			 *	maintain caller chain
			 */

			callerBC(method) = (rp_t)ac;
			ipC(method) = initIPBC(method);
			spC(method) = integerObjectOf(1);
			ac = (oop_t)method;
			assert((rp_t)ac != nilOop,  "nil ac in Bvalue:");
			assert(FutureSurvivors.sp_bottom > ac 
			    ||  ac >= FutureSurvivors.sp_top,
			    "ac in wrong space");
			if (checkPoll())
				return (method);
			fetchLocals(r1);
			break;

		case 203:	/* do: */
			adb(_BsendDo);
			doASend(specialSelOf(54), specialNargOf(54));

		case 204:	/* new */
			adb(_BsendNew);
			doASend(specialSelOf(56), specialNargOf(56));

		case 205:	/* new: */
			adb(_BsendNewCol);
			doASend(specialSelOf(58), specialNargOf(58));

		case 206:	/* x */
			adb(_BsendX);
			r1 = *--sp;
			r2 = (oop_t)method;	/* steal method */
			method = (rp_t)r1;
			if (isIntegerObject(r1)  
			    ||  classRp(method) != classPointOop) {
				++sp;
				method = (rp_t)r2;
				doASend(specialSelOf(60), specialNargOf(60));
			}
			*sp++ = xPt(method);
			method = (rp_t)r2;
			break;

		case 207:	/* y */
			adb(_BsendY);
			r1 = *--sp;
			r2 = (oop_t)method;	/* steal method */
			method = (rp_t)r1;
			if (isIntegerObject(r1)  
			    ||  classRp(method) != classPointOop) {
				++sp;
				method = (rp_t)r2;
				doASend(specialSelOf(62), specialNargOf(62));
			}
			*sp++ = yPt(method);
			method = (rp_t)r2;
			break;

		/*
		 *	end of sends
		 */

		/*
		 *	returns
		 */

		case 120: 	/* return self */
			adb(_BreturnSelf);
			returnIt(rcvr, senderMC(hc));

		case 121: 	/* return true */
			adb(_BreturnTrue);
			returnNonCon(trueOop);

		case 122: 	/* return false */
			adb(_BreturnFalse);
			returnNonCon(falseOop);

		case 123: 	/* return nil */
			adb(_BreturnNil);
			returnNonCon(nilOop);

		case 124:	/* return stack top from message */
			adb(_BreturnTopMess);
			returnIt(*--sp, senderMC(hc));
		
		case 125:	/* return top from block */
			adb(_BreturnTopBlock);
			returnIt(*--sp, callerBC((rp_t)ac));

		/*
		 *	end of returns
		 */
		} /* end of decode switch() */
	} /* end of fetch/execute for() loop */
	/*NOTREACHED*/
	/*
	 *	lint won't shut up so we commented this out:
	 *	fatal("executeBlock: should never reach this point", NullOop);
	 */
}
