static char execute_h[] = "$Header: execute.h,v 41.1 84/03/14 19:58:53 pkl Exp $";

/*
 *	Copyright (C) 1983 by the Regents of University of California 
 *	All Rights Reserved.
 */

/*
 *	Common macros for execution of blocks and methods on BS.
 *
 *	Costly checks like checking for input or checking for running
 *	out of new space occur periodically.  Sends and backward
 *	branches use checkPoll to see if it's time to check.
 *	In this version, instead of checkPoll counting down and
 *	interrupting execution every 10th send & jump,
 *	we call polling routines every tenth of a second.
 *	If the polling routines detect input, etc, they call
 *	forcePoll, which clears pollCount.
 */

extern rp_t	executeBlock(), executeMethod(), methodSend();

extern void	execute(), initTimeData(), 
		reportTimeData(), synchronousSignal(),
		stackTrace(), halt();

extern u_int	cycle, pollCount;


# define isTimeToPoll() \
	(pollCount == 0)


# define checkPoll()		(pollCount == 0)
# define resetPollCount()	(pollCount = 1)
# define forcePoll()		(pollCount = 0)


# ifndef DBTRACE
#	define checkDbTrace(pc, sp)	TRUE
# endif

# ifndef BREAKPOINT
#	define checkBreakpoint()	TRUE
# endif
