static char rcsId[] = "$Header: filbuf.c,v 41.1 84/03/14 20:14:05 pkl Exp $";

/*
 *	Copyright (C) 1983 by the Regents of University of California 
 *	All Rights Reserved.
 */

/* @(#)filbuf.c	4.6 (Berkeley) 6/30/83 */
/*
 *	Modified for BS by dmu 11/1/83 to read despite signals.
 */

#include	<stdio.h>
#include	<sys/types.h>
#include	<sys/stat.h>

char	*malloc();


/*
 *	Modified to repeatedly read from fd until len bytes are read,
 *	or when error is encountered.  Always return the number of 
 *	characters read.
 */

static int
myread(fd, buf, len)
register int fd, len;
register char *buf;
{
	register int n, mylen;

	for (mylen = len;  mylen > 0;  mylen -= n,  buf += n) {
		n = read(fd, buf, mylen);
		if (n <= 0)
			break;
	}
	return (len - mylen);
}

_filbuf(iop)
register FILE *iop;
{
	int size;
	struct stat stbuf;
	static char smallbuf[_NFILE];
	extern char _sibuf[];

	if (iop->_flag & _IORW)
		iop->_flag |= _IOREAD;

	if ((iop->_flag&_IOREAD) == 0)
		return(EOF);
	if (iop->_flag&(_IOSTRG|_IOEOF))
		return(EOF);
tryagain:
	if (iop->_base==NULL) {
		if (iop->_flag&_IONBF) {
			iop->_base = &smallbuf[fileno(iop)];
			goto tryagain;
		}
		if (fstat(fileno(iop), &stbuf) < 0 || stbuf.st_blksize <= NULL)
			size = BUFSIZ;
		else
			size = stbuf.st_blksize;
		if (iop == stdin)
			iop->_base = _sibuf;
		else {
			if ((iop->_base = malloc(size)) == NULL) {
				iop->_flag |= _IONBF;
				goto tryagain;
			}
			iop->_flag |= _IOMYBUF;
		}
		iop->_bufsiz = size;
	}
	if (iop == stdin) {
		if (stdout->_flag&_IOLBF)
			fflush(stdout);
		if (stderr->_flag&_IOLBF)
			fflush(stderr);
	}
	iop->_cnt = myread(fileno(iop), iop->_base,
		iop->_flag & _IONBF ? 1 : iop->_bufsiz);
	iop->_ptr = iop->_base;
	if (--iop->_cnt < 0) {
		if (iop->_cnt == -1) {
			iop->_flag |= _IOEOF;
			if (iop->_flag & _IORW)
				iop->_flag &= ~_IOREAD;
		} else
			iop->_flag |= _IOERR;
		iop->_cnt = 0;
		return(-1);
	}
	return(*iop->_ptr++&0377);
}
