static char rcsId[] = "$Header: flsbuf.c,v 41.2 84/04/05 22:15:17 dmu Exp $ Berkekey Smalltalk Version";

/*
 *	Copyright (C) 1983 by the Regents of University of California 
 *	All Rights Reserved.
 */

/* 
 *	Original Sccs Id: @(#)flsbuf.c	4.2 (Berkeley) 3/9/81 
 *
 *	Calls to write() has been modified to mywrite(), which 
 *	checks for partial counts returned from vanilla write().
 */

#include	<stdio.h>

char	*malloc();


/*
 *	They are missing from the Sun Libaray
 */

char	_sobuf[BUFSIZ], _sibuf[BUFSIZ];


/*
 *	Keep trying till it's all written.
 *
 *	Stolen from the library, it has been modified to understand 
 *	it when a write returns a partial count.  This happens when
 *	a signal arrives whilst writing bits to the AED.  It is
 *	vital to not drop any of them.
 */

static int
mywrite(fd, buf, len)
register int fd, len;
register char *buf;
{
	register int	n, mylen;

	for (mylen = len;  mylen > 0;  mylen -= n,  buf += n) {
		n = write(fd, buf, mylen);
		if (n <= 0)
			break;
	}
	return (len - mylen);
}


/*
 *	The rest of this file is pretty much standard.
 */

_flsbuf(c, iop)
int c;
register FILE *iop;
{
	register char *base;
	register n, rn;
	char c1;
	extern char _sobuf[];

	if (iop->_flag & _IORW) {
		iop->_flag |= _IOWRT;
		iop->_flag &= ~_IOEOF;
	}

	if ((iop->_flag&_IOWRT)==0)
		return(EOF);
tryagain:
	if (iop->_flag&_IOLBF) {
		base = iop->_base;
		*iop->_ptr++ = c;
		if (iop->_ptr >= base+BUFSIZ || c == '\n') {
			n = mywrite(fileno(iop), base, rn = iop->_ptr - base);
			iop->_ptr = base;
		} else
			rn = n = 0;
		iop->_cnt = 0;
	} else if (iop->_flag&_IONBF) {
		c1 = c;
		rn = 1;
		n = mywrite(fileno(iop), &c1, rn);
		iop->_cnt = 0;
	} else {
		if ((base=iop->_base)==NULL) {
			if (iop==stdout) {
				if (isatty(fileno(stdout)))
					iop->_flag |= _IOLBF;
				iop->_base = _sobuf;
				iop->_ptr = _sobuf;
				goto tryagain;
			}
			if ((iop->_base=base=malloc(BUFSIZ)) == NULL) {
				iop->_flag |= _IONBF;
				goto tryagain;
			}
			iop->_flag |= _IOMYBUF;
			rn = n = 0;
		} else if ((rn = n = iop->_ptr - base) > 0) {
			iop->_ptr = base;
			n = mywrite(fileno(iop), base, n);
		}
		iop->_cnt = BUFSIZ-1;
		*base++ = c;
		iop->_ptr = base;
	}
	if (rn != n) {
		iop->_flag |= _IOERR;
		return(EOF);
	}
	return(c);
}

fflush(iop)
register struct _iobuf *iop;
{
	register char	*base;
	register	n;

	if ((iop->_flag&(_IONBF|_IOWRT))==_IOWRT
	 && (base=iop->_base)!=NULL && (n=iop->_ptr-base)>0) {
		iop->_ptr = base;
		iop->_cnt = (iop->_flag&(_IOLBF|_IONBF)) ? 0 : BUFSIZ;
		if (mywrite(fileno(iop), base, n)!=n) {
			iop->_flag |= _IOERR;
			return(EOF);
		}
	}
	return(0);
}


/*
 *	Flush buffers on exit
 */

_cleanup()
{
	register struct _iobuf *iop;
	extern struct _iobuf *_lastbuf;

	for (iop = _iob; iop < _lastbuf; iop++)
		(void)fclose(iop);
}


fclose(iop)
register struct _iobuf *iop;
{
	register r;

	r = EOF;
	if (iop->_flag&(_IOREAD|_IOWRT|_IORW) && (iop->_flag&_IOSTRG)==0) {
		r = fflush(iop);
		if (close(fileno(iop)) < 0)
			r = EOF;
		if (iop->_flag&_IOMYBUF)
			free(iop->_base);
		if (iop->_flag&(_IOMYBUF|_IONBF|_IOLBF))
			iop->_base = NULL;
	}
	iop->_flag &= ~(_IOREAD|_IOWRT|_IOLBF|_IONBF|_IOMYBUF|_IOERR|_IOEOF|_IOSTRG|_IORW);
	iop->_cnt = 0;
	return(r);
}
