static char mc_h[] = "$Header: mc.h,v 41.1 84/03/14 20:01:31 pkl Exp $";

/*
 *	Copyright (C) 1983 by the Regents of University of California 
 */

/*
 *	Defines method cache interface for BS.
 *	Could stand some more abstraction.
 *
 *	The idea is to cache as much as possible to hasten sends.
 *	No reprobes.
 *
 *	Enlarged to shorts and padded for SUN
 *	Cache slots must be 32 bytes long for probe function
 */

struct methodCache {
	rp_t	mc_class;	/* class of method */
	rp_t	mc_sel;		/* selector */
	rp_t	mc_method;	/* points to method cached */
	byte_t  *mc_pc;		/* points to program counter */
	short	mc_whatKind;
#		define	FULL_SEND	(short)0
#		define	RET_SELF	(short)1
#		define	RET_INST	(short)2
#		define	PRIMITIVE	(short)3
	short	mc_large;	/* boolean: large context */
	short	mc_index;	/* primitive or instance index */
	short	mc_tempCount;	/* includes arg count, see book */
	short	mc_padding[4];	/* pads out to power of 2 */
};


# define cacheSize	2048		/* must be power of two */
# define cacheSlotSizeLog	5	/* cache slot is 1 << 5 bytes long */


/*
 *	Hash function is a little tricky, since these are word pointers.
 *	Structure size (2**5) is WIRED IN.
 */

# define cacheSlot(class, sel)\
    ((struct methodCache *)&((char *)MethodCache)[\
	((int)sel ^ (int)class)   &   cacheSize - 1  <<  cacheSlotSizeLog])


extern struct methodCache	MethodCache[cacheSize];
extern void			smashCache();
