static char mem_h[] = "$Header: mem.h,v 41.1 84/03/14 20:02:13 pkl Exp $";

/*
 *	Copyright (C) 1983 by the Regents of University of California 
 *	All Rights Reserved.
 */

/*
 *	This file furnishes the memory system macros for BS.
 */

# include	"rp.h"		/* real pointer stuff */
# include	"si.h"		/* small integers */
# include	"reg.h"		/* registry */
# include	"if.h"		/* instantiation and freeing */
# include	"trace.h"	/* trace macros */


/*
 *	Traverse the object pointed to by ``rp'' (defined in instantiator).
 *	Perform ``whatToDo'' on each oop, and fix the field in ``rp''
 *	if ``updateRp'' evaluates to true.  ``whatToDo'' is a 
 *	macro with source and dest arguments.
 *	
 *	If-then-else is used instead of switch-case for speed.
 */

# define traverseObject(updateRp, whatToDo)\
	if (TRUE) {\
		register oop_t	oop, *oopp, *endp;\
		register u_int	format;\
		\
		/*\
		 *	fix pointer to class object\
		 */\
		oop = (oop_t)classRp(rp);\
		whatToDo(oop, *(oop_t *)&classRp(rp));\
		format = formatRp(rp);\
		/*\
		 *	fix object itself\
		 */\
		if (format == OOPS) {\
			oopp = oopFieldRp(rp);\
			endp = &oopp[lengthRp(rp)];\
			while (oopp < endp) { /* traverse object */\
				oop = *oopp++;\
				whatToDo(oop, oopp[-1]);\
			}\
			if (updateRp)\
				rp = (rp_t)oopp;\
		}\
		else if (format == COMPILED_METHOD) {\
			oopp = oopFieldRp(rp);\
			endp = &oopp[objectPointerCountCMH(headerCM(rp))];\
			while (oopp < endp) { /* traverse object */\
				oop = *oopp++;\
				whatToDo(oop, oopp[-1]);\
			}\
			if (updateRp)\
				rp = (rp_t)&byteFieldRp(rp)[\
				    roundUp(lengthRp(rp), sizeof(oop_t))];\
		}\
		else if (format == BYTES) /* dangling else */ {\
			if (updateRp)\
				rp = (rp_t)&byteFieldRp(rp)[\
				    roundUp(lengthRp(rp), sizeof(oop_t))];\
		}\
		else if (format == BES) /* dangling else */ {\
			if (updateRp)\
				rp = (rp_t)&BEFieldRp(rp)[roundUp\
				    (lengthRp(rp),\
				      sizeof(oop_t) / sizeof(BE_t))];\
		}\
		else\
			fatal("traverseObject: bad format", NullOop);\
	}\
	else\


extern void	ageInstances(), reorganize(), verifyImage();
