static char rcsId[] = "$Header: mouse.c,v 44.1 84/04/06 01:37:39 dmu Exp $";

/*
 *	Copyright (C) 1983 by the Regents of University of California 
 */

/*
 *	This file is an object-oriented interface to the current mouse
 *	position.
 *	2 reasons for it:
 *		1. So we can implement the Mouse position polling primitive
 *		   which is faster than letting ST cons a point.
 *		2. So we can find out where the cursor is when it unlinked.
 */


# include	<stdio.h>

# include	"utils.h"
# include	"mem.h"
# include	"io.h"
# include	"execute.h"


/*
 *	These remember the last mouse position, simulating registers
 *	on the Alto.
 */

static u_int	altoMouseX, altoMouseY;


void
getMouseCoordinates(xp, yp)
u_int *xp, *yp;
{
	*xp = altoMouseX, *yp = altoMouseY;
}


/*
 *	Set the mouse positions to x and y.
 */

void
setMouseToXY(x, y)
register int x, y;
{
	altoMouseX = x,  altoMouseY = y;
}
