static char rcsId[] = "$Header: primTable.c,v 41.8 84/07/17 22:01:57 dmu Exp $ Smalltalk";

/*
 *	Copyright (C) 1983 by the Regents of University of California 
 *	All Rights Reserved.
 */

/*
 *	All this file contains is initialization of the primitive dispatch table
 *	and the unimplemented primitive stubs.
 */

# include	<stdio.h>
# include	"utils.h"
# include	"mem.h"
# include	"primTable.h"


rp_t 	(*primitiveDispatchTable[])() = {	/* used in sends.m */
	UnImplPrm,	/* 0 */
	SIAddPrm,	/* 1 */
	SISubPrm,	/* 2 */
	SILtPrm,	/* 3 */
	SIGtPrm,	/* 4 */
	SILePrm,	/* 5 */
	SIGePrm,	/* 6 */
	SIEqPrm,	/* 7 */
	SINeqPrm,	/* 8 */
	SIMulPrm,	/* 9 */
	SISlashPrm,	/* 10 */
	SIModPrm,	/* 11 */
	SISlSlPrm,	/* 12 */
	SIQuoPrm,	/* 13 */
	SIAndPrm,	/* 14 */
	SIOrPrm,	/* 15 */
	SIXorPrm,	/* 16 */
	SIAslPrm,	/* 17 */
	NumbAtPrm,	/* 18 */
	UnImplPrm,	/* 19 */
	UnImplPrm,	/* 20 */
	UnImplPrm,	/* 21 */
	UnImplPrm,	/* 22 */
	UnImplPrm,	/* 23 */
	UnImplPrm,	/* 24 */
	UnImplPrm,	/* 25 */
	UnImplPrm,	/* 26 */
	UnImplPrm,	/* 27 */
	UnImplPrm,	/* 28 */
	UnImplPrm,	/* 29 */
	UnImplPrm,	/* 30 */
	UnImplPrm,	/* 31 */
	UnImplPrm,	/* 32 */
	UnImplPrm,	/* 33 */
	UnImplPrm,	/* 34 */
	UnImplPrm,	/* 35 */
	UnImplPrm,	/* 36 */
	UnImplPrm,	/* 37 */
	UnImplPrm,	/* 38 */
	UnImplPrm,	/* 39 */
	SIAsFloatPrm,	/* 40 */
	FloatAddPrm,	/* 41 */
	FloatSubPrm,	/* 42 */
	FloatLtPrm,	/* 43 */
	FloatGtPrm,	/* 44 */
	FloatLePrm,	/* 45 */
	FloatGePrm,	/* 46 */
	FloatEqPrm,	/* 47 */
	FloatNeqPrm,	/* 48 */
	FloatMulPrm,	/* 49 */
	FloatSlPrm,	/* 50 */
	FloatTruncPrm,	/* 51 */
	FloatFractPrm,	/* 52 */
	FloatExpPrm,	/* 53 */
	FloatPowPrm,	/* 54 */
	UnImplPrm,	/* 55 */
	UnImplPrm,	/* 56 */
	UnImplPrm,	/* 57 */
	UnImplPrm,	/* 58 */
	UnImplPrm,	/* 59 */
	ObjAtPrm,	/* 60 */
	ObjAtPutPrm,	/* 61 */
	ObjSizePrm,	/* 62 */
	StringAtPrm,	/* 63 */
	StringAtPutPrm,	/* 64 */
	RSNextPrm,	/* 65 */
	WSNextPutPrm,	/* 66 */
	PSAtEndPrm,	/* 67 */
	CMObjAtPrm,	/* 68 */
	CMObjAtPutPrm,	/* 69 */
	BehavNewPrm,	/* 70 */
	BehavNewColPrm,	/* 71 */
	ObjBecomePrm,	/* 72 */
	ObjIVAtPrm,	/* 73 */
	ObjIVAtPutPrm,	/* 74 */
	ObjAsOopPrm,	/* 75 */
	SIAsObjPrm,	/* 76 */
	BehavSomePrm,	/* 77 */
	ObjNextInstPrm,	/* 78 */
	CMCNewMethPrm,	/* 79 */
	CBlockCopyPrm,	/* 80 */
	BCValuePrm,	/* 81 */
	BCValArgsPrm,	/* 82 */
	ObjPerfPrm,	/* 83 */
	ObjPerfArgsPrm,	/* 84 */
	SemSigPrm,	/* 85 */
	SemWaitPrm,	/* 86 */
	ProcResPrm,	/* 87 */
	ProcSuspPrm,	/* 88 */
	BehavFlsCchPrm,	/* 89 */
	SensorMousePrm,	/* 90 */
	InpStCrsPutPrm,	/* 91 */
	CFCCursLinkPrm,	/* 92 */
	InpStInSemPrm,	/* 93 */
	InpStSmpIntPrm,	/* 94 */
	InpStInpWdPrm,	/* 95 */
	BBCopyBitsPrm,	/* 96 */
	SDSnapshotPrm,	/* 97 */
	TimeCTimePrm,	/* 98 */
	TimeCTickPrm,	/* 99 */
	PSAtTickPrm,	/* 100 */
	CFBeCursPrm,	/* 101 */
	DFBeDispPrm,	/* 102 */
	TSScanPrm,	/* 103 */
	BBDrawLoopXY,	/* 104 */
	StringReplPrm,	/* 105 */
	UnImplPrm,	/* 106 */
	UnImplPrm,	/* 107 */
	UnImplPrm,	/* 108 */
	UnImplPrm,	/* 109 */
	ObjEqPrm,	/* 110 */
	ObjClassPrm,	/* 111 */
	SDCorePrm,	/* 112 */
	SDQuitPrm,	/* 113 */
	SDExitPrm,	/* 114 */
	SDOopsPrm,	/* 115 */
	SDSigAtOopPrm,	/* 116 */
	UnImplPrm,	/* 117 */
	UnImplPrm,	/* 118 */
	UnImplPrm,	/* 119 */
	UnImplPrm,	/* 120 */
	UnImplPrm,	/* 121 */
	UnImplPrm,	/* 122 */
	UnImplPrm,	/* 123 */
	UnImplPrm,	/* 124 */
	UnImplPrm,	/* 125 */
	UnImplPrm,	/* 126 */
	UnImplPrm,	/* 127 */
	UnImplPrm,	/* 128 */
	UnImplPrm,	/* 129 */
	UnImplPrm,	/* 130 */
	UnImplPrm,	/* 131 */
	UnImplPrm,	/* 132 */
	UnImplPrm,	/* 133 */
	UnImplPrm,	/* 134 */
	UnImplPrm,	/* 135 */
	UnImplPrm,	/* 136 */
	UnImplPrm,	/* 137 */
	UnImplPrm,	/* 138 */
	UnImplPrm,	/* 139 */
	UnImplPrm,	/* 140 */
	UnImplPrm,	/* 141 */
	UnImplPrm,	/* 142 */
	UnImplPrm,	/* 143 */
	UnImplPrm,	/* 144 */
	UnImplPrm,	/* 145 */
	UnImplPrm,	/* 146 */
	UnImplPrm,	/* 147 */
	UnImplPrm,	/* 148 */
	UnImplPrm,	/* 149 */
	UnImplPrm,	/* 150 */
	UnImplPrm,	/* 151 */
	UnImplPrm,	/* 152 */
	UnImplPrm,	/* 153 */
	UnImplPrm,	/* 154 */
	UnImplPrm,	/* 155 */
	UnImplPrm,	/* 156 */
	UnImplPrm,	/* 157 */
	UnImplPrm,	/* 158 */
	UnImplPrm,	/* 159 */
	UnImplPrm,	/* 160 */
	UnImplPrm,	/* 161 */
	UnImplPrm,	/* 162 */
	UnImplPrm,	/* 163 */
	UnImplPrm,	/* 164 */
	UnImplPrm,	/* 165 */
	UnImplPrm,	/* 166 */
	UnImplPrm,	/* 167 */
	UnImplPrm,	/* 168 */
	UnImplPrm,	/* 169 */
	UnImplPrm,	/* 170 */
	UnImplPrm,	/* 171 */
	UnImplPrm,	/* 172 */
	UnImplPrm,	/* 173 */
	UnImplPrm,	/* 174 */
	UnImplPrm,	/* 175 */
	UnImplPrm,	/* 176 */
	UnImplPrm,	/* 177 */
	UnImplPrm,	/* 178 */
	UnImplPrm,	/* 179 */
	UnImplPrm,	/* 180 */
	UnImplPrm,	/* 181 */
	UnImplPrm,	/* 182 */
	UnImplPrm,	/* 183 */
	UnImplPrm,	/* 184 */
	UnImplPrm,	/* 185 */
	UnImplPrm,	/* 186 */
	UnImplPrm,	/* 187 */
	UnImplPrm,	/* 188 */
	UnImplPrm,	/* 189 */
	UnImplPrm,	/* 190 */
	UnImplPrm,	/* 191 */
	UnImplPrm,	/* 192 */
	UnImplPrm,	/* 193 */
	UnImplPrm,	/* 194 */
	UnImplPrm,	/* 195 */
	UnImplPrm,	/* 196 */
	UnImplPrm,	/* 197 */
	UnImplPrm,	/* 198 */
	UnImplPrm,	/* 199 */
	UDOpenPrm,	/* 200 */
	UFCSeekPrm,	/* 201 */
	UFCReadPrm,	/* 202 */
	UFCWritePrm,	/* 203 */
	UFCClosePrm,	/* 204 */
	UDCreatPrm,	/* 205 */
	UFCBootPrm,	/* 206 */
	CMInitialPC,	/* 207 */
	SDProfPrm,	/* 208 */
	UFCSnapPrm,	/* 209 */
	UFCFtruncPrm,	/* 210 */
	UFCUnlinkPrm,	/* 211 */
	UFCLinkPrm,	/* 212 */
	UPCSpawnPrm,	/* 213 */
	SDReorgPrm,	/* 214 */
	SDOldLeftPrm,	/* 215 */
	SDSuspendPrm,	/* 216 */
	StringSystemPrm,/* 217 */
	URUGetRUsagePrm,/* 218 */
	SDOldUsedPrm,	/* 219 */
	CFCCursChgPrm,	/* 220 */
	UDOpenDirPrm,	/* 221 */
	UDReadDirPrm,	/* 222 */
	UnImplPrm,	/* 223 */
	UnImplPrm,	/* 224 */
	UnImplPrm,	/* 225 */
	UnImplPrm,	/* 226 */
	UnImplPrm,	/* 227 */
	UnImplPrm,	/* 228 */
	UnImplPrm,	/* 229 */
	UnImplPrm,	/* 230 */
	UnImplPrm,	/* 231 */
	UnImplPrm,	/* 232 */
	UnImplPrm,	/* 233 */
	UnImplPrm,	/* 234 */
	UnImplPrm,	/* 235 */
	UnImplPrm,	/* 236 */
	UnImplPrm,	/* 237 */
	UnImplPrm,	/* 238 */
	UnImplPrm,	/* 239 */
	UnImplPrm,	/* 240 */
	UnImplPrm,	/* 241 */
	UnImplPrm,	/* 242 */
	UnImplPrm,	/* 243 */
	UnImplPrm,	/* 244 */
	UnImplPrm,	/* 245 */
	UnImplPrm,	/* 246 */
	UnImplPrm,	/* 247 */
	UnImplPrm,	/* 248 */
	UnImplPrm,	/* 249 */
	UnImplPrm,	/* 250 */
	UnImplPrm,	/* 251 */
	UnImplPrm,	/* 252 */
	UnImplPrm,	/* 253 */
	UnImplPrm,	/* 254 */
	UnImplPrm	/* 255 */
};


/*
 *	Stub for unimplemented primitives.
 */

rp_t
UnImplPrm()
{
	return(NullOop);
}
