static char primTable_h[] = "$Header: primTable.h,v 41.7 84/07/17 22:02:20 dmu Exp $ Smalltalk";

/*
 *	Copyright (C) 1983 by the Regents of University of California 
 *	All Rights Reserved.
 */

/*
 *	Declarations for dispatch table for primitives.  Those that don't have
 *	special bytecodes are implemented with subroutines.
 *
 *	The primitive interface:
 *		each routine gets passed
 *		rp:	pointer to receiver in the context stack
 *		ac:	active context, which contains pc, sender, etc.
 *		nargs:	number of arguments
 *
 *		on failure it returns NullOop,
 *		on success it returns the active context (may be a new one).
 *		The sp in the context is taken care of by the caller for
 *		the normal cases.
 */

# define	NPRIMS	256

extern	rp_t	(*primitiveDispatchTable[])(),
	BBCopyBitsPrm(), BBDrawLoopXY(), BCBlkCpyPrm(), BCValArgsPrm(), 
	BCValuePrm(),
	BehavFlsCchPrm(), BehavNewColPrm(), BehavNewPrm(), BehavSomePrm(),
	CFBeCursPrm(), CFCCursLinkPrm(), CFCCursChgPrm(),
	CMCNewMethPrm(), CMObjAtPrm(),
	CMObjAtPutPrm(), DFBeDispPrm(), FloatAddPrm(), FloatEqPrm(),
	FloatExpPrm(), FloatFractPrm(), FloatGtPrm(), FloatLtPrm(),
	FloatGePrm(), FloatLePrm(),
	FloatMulPrm(), FloatNeqPrm(), FloatPowPrm(), FloatSlPrm(),
	FloatSubPrm(), FloatTruncPrm(), InpStCrsPutPrm(), InpStInSemPrm(),
	InpStInpWdPrm(), InpStSmpIntPrm(),
	NumbAtPrm(), ObjAsOopPrm(), ObjAtPrm(),
	ObjAtPutPrm(), ObjBecomePrm(), ObjClassPrm(), ObjEqPrm(),
	ObjIVAtPrm(), ObjIVAtPutPrm(), ObjNextInstPrm(), ObjPerfArgsPrm(),
	ObjPerfPrm(), ObjSizePrm(), PSAtEndPrm(), PSAtTickPrm(),
	ProcResPrm(), ProcSuspPrm(), RSNextPrm(), SDCorePrm(),
	SDExitPrm(), SDOldLeftPrm(), SDOldUsedPrm(), SDOopsPrm(), SDProfPrm(),
	SDQuitPrm(),
	SDReorgPrm(), SDSigAtOopPrm(), SDSuspendPrm(),
	SDSnapshotPrm(), SIAddPrm(), SIAndPrm(), SIAsFloatPrm(),
	SIAsObjPrm(), SIAslPrm(), SIEqPrm(), SIGePrm(), SIGtPrm(),
	SILtPrm(), SILePrm(), SIModPrm(), SIMulPrm(), SINeqPrm(),
	SIOrPrm(), SIQuoPrm(), SISlSlPrm(), SISlashPrm(),
	SISubPrm(), SIXorPrm(), SemSigPrm(), SemWaitPrm(),
	SensorMousePrm(), StringAtPrm(), StringAtPutPrm(), StringReplPrm(),
	StringSystemPrm(),
	TSScanPrm(), TimeCTickPrm(), TimeCTimePrm(),
	UDOpenDirPrm(), UDReadDirPrm(),
	UDOpenPrm(), UFCClosePrm(), UFCFtruncPrm(), UFCLinkPrm(),
	UFCReadPrm(), UFCSeekPrm(), UFCUnlinkPrm(),
	UFCWritePrm(), UnImplPrm(), WSNextPutPrm(), UDCreatPrm(),
	UFCBootPrm(), UFCSnapPrm(), UPCSpawnPrm(), URUGetRUsagePrm(),
	YorpPrm(), CMInitialPC(), CBlockCopyPrm();
