static char prims_h[] = "$Header: prims.h,v 41.1 84/03/14 20:03:43 pkl Exp $";

/*
 *	Copyright (C) 1983 by the Regents of University of California 
 *	All Rights Reserved.
 */


/*
 *	Tests "pred" and returns the trueOop or falseOop to the receiver 
 *	according to the truth value of "pred".  Will be used in the 
 *	implementation smallInteger and floating point relation primitives.
 *	Avoids ?: because it doesn't compile as well.
 */

# define relationFinish(pred) \
	if (pred) \
		*rp = (oop_t)trueOop;\
	else \
		*rp = (oop_t)falseOop;\
	return (ac)

/*
 *	real time in msec.
 */

# define getMillisecondClock(dest) \
	if (TRUE) {\
		struct timeb timeb;\
		ftime(&timeb);\
		dest = timeb.time * 1000  +  timeb.millitm;\
	}\
	else


/*
 *	used in the timing primitives to factor
 *	the interface to UNIX
 */

enum timeOrTick { timeNotTick, tickNotTime };


/*
 *	Input queue:
 *
 *	BS uses a circular-array to queue input events.
 */

# define qLength	(1 << 10)	/* must be power of 2 */
# define qMask		(qLength - 1)

/*
 *	Increment queue's pointer by one (modulo qLength-1).
 */

# define qInc(x) \
	if (TRUE) {\
		++(x);\
		(x) &= qMask;\
	}\
	else


/*
 *	Decrement queue's pointer by one (modulo qLength-1).
 */

# define qDec(x)\
	if (TRUE) {\
		--(x);\
		(x) &= qMask;\
	}\
	else


/*
 *	Structure of a queue is two pointers (one to first object
 *	and one to next empty locaion), and a array for storing 
 *	the objects.
 */

struct	queue {
	u_int	q_h;			/* head */
	u_int	q_t;			/* tail + 1 */
	int	q_a[qLength];		/* stores the events */
};


/*
 *	Allocates and initializes a new queue called "name."
 */

# define newQueue(name) \
	struct queue name = {0, 0}


# define isEmptyQueue(p)	((p)->q_h  ==  (p)->q_t)


/*
 *	Puts "w" to the queue "p".  If queue is full already, silently toss it.
 */

# define enqueue(p, w) \
	if (TRUE) {\
		(p)->q_a[(p)->q_t] = (w);\
		qInc((p)->q_t);\
		if (isEmptyQueue(p)) \
			qDec((p)->q_t);\
	}\
	else


/*
 *	Removes the first item from the queue "p" and puts it in "w".  
 *	Caller must first check with isEmptyQueue().
 */

# define dequeue(p, w) \
	if (TRUE) {\
		(w) = (p)->q_a[(p)->q_h];\
		qInc((p)->q_h);\
	}\
	else


# define QuitMsg	"quit primitive invoked"


/*
 *	some macros to unpack things
 */

/*
 *	Used by primitives to grab a SmallInt and toss the tag.
 */

# define getInt(src, dest, failure) \
	if (TRUE) {\
		(dest) = (src);\
		if (!isIntegerObject(dest))\
			return (failure);\
		convertToInteger(dest);\
	}\
	else


/*
 *	Used by primitives to grab a ST string.
 *	C expects a null byte at the end, so the data must be copied.
 *	dest must be at least BUFSIZ long.
 */

# define getString(src, dest, failure) \
	if (TRUE) {\
		register rp_t _getSoop;\
		register u_int _getSsize;\
		\
		_getSoop = (rp_t)(src);\
		if (isIntegerObject((oop_t)_getSoop)\
		    ||  formatRp(_getSoop) != BYTES\
		    ||  (_getSsize = lengthRp(_getSoop)) >= BUFSIZ)\
			return (failure);\
		bcopy((char *)(byteFieldRp(_getSoop)), dest, _getSsize);\
		dest[_getSsize] = '\0';\
	}\
	else


extern void		thinkTime(), readAll(), serviceTimer();
extern struct queue	InputBuffer;
