static char *rcsid = "$Header: unixProc.c,v 41.4 84/07/25 20:21:25 pkl Exp $";

/*
 *	subprocesses for Smalltalk
 *
 *	Doesn't work.
 */


# include	<stdio.h>
# include	<signal.h>
# include	<errno.h>
# include	<sys/wait.h>
# include	<sgtty.h>
# include	<sys/time.h>
# include	<sys/file.h>
# include	<sys/types.h>
# include	<sys/stat.h>

# include	"utils.h"
# include	"mem.h"
# include	"io.h"
# include	"prims.h"

static void childSig(), findPty();


# define commandUP(aUP)	(rpFieldRp(aUP)[0])
# define pidUP(aUP)	(oopFieldRp(aUP)[1])
# define fdUP(aUP)	(oopFieldRp(aUP)[2])


/*
 *	primitive 217 simply perform command in receiver string
 *	does not really belong in this file
 */

rp_t
StringSystemPrm(rp, ac)
rp_t *rp, ac;
{
	register char commandString[BUFSIZ];

	getString(rp[0], commandString, NullOop);
	system(commandString);
	return (ac);
}


rp_t
UPCSpawnPrm(rp, ac)
rp_t *rp, ac;
{
	int    ptyFd, ttyFd;
	register pid, i;
	register rp_t aUnixProc; 
	register char commandString[BUFSIZ];

	getString(rp[1], commandString, NullOop);

	findPty(&ptyFd, &ttyFd);
	if (ttyFd < 0) {
		warning ("createProcess: Can't get a pty\n");
		return (NullOop);
	}
	sigset(SIGALRM, SIG_IGN);
	sighold(SIGCHLD);
	sigset(SIGCHLD, childSig);
    
	pid = vfork();

	if (pid == 0) {
		struct sgttyb sg; struct tchars tc; struct ltchars ltc;
		int ld = NTTYDISC;

		sigrelse(SIGCHLD);
		sigsys(SIGINT, SIG_DFL);
		sigsys(SIGQUIT, SIG_DFL);

		setpgrp(0, getpid());

		ioctl(0, TIOCGLTC, &ltc);
		ioctl(0, TIOCGETC, &tc);
		close(0), close(1), close (2);
		dup (ttyFd), dup (ttyFd), dup (ttyFd);
		for (i = 3;  i < 20;  i++)
			close(i);

		/* sttys ? */
		CloseWindow(TRUE);
		gtty(0, &sg);
		sg.sg_flags = EVENP|ODDP;
		sg.sg_erase = sg.sg_kill = -1;
		stty(0, &sg);

		ioctl(0, TIOCSETC, &tc);
		ioctl(0, TIOCSLTC, &ltc);

		ioctl(0, TIOCSETD, &ld);

		execlp("/bin/csh", "/bin/csh", "-c", commandString, 0);
		write(2, "Couldn't exec the shell\n", 24);
		_exit(1);
	}

	close(ttyFd);

	if (pid < 0)
		warning("Fork failed");
	else {
		aUnixProc = instantiateClass(rp[0], 0);
		if (formatRp(aUnixProc) != OOPS  ||  lengthRp(aUnixProc) < 3)
			warning("UnixProcess: bad definition");
		else {
			commandUP(aUnixProc) = rp[1];
			ggcStore(aUnixProc, rp[1]);
			pidUP(aUnixProc) = integerObjectOf(pid);
			fdUP(aUnixProc) = integerObjectOf(ptyFd);
			rp[0] = aUnixProc;

			sigrelse(SIGCHLD);
			sigset(SIGALRM, serviceTimer);
			return (ac);
		}
	}
	sigrelse(SIGCHLD);
	sigset(SIGALRM, serviceTimer);
	close(ptyFd);
	return (NullOop);
}


static void
childSig ()
{
	register int pid;
	union wait w;
	extern int errno;

	while (pid = wait3(&w.w_status,  WUNTRACED | WNOHANG,  0)) {
		if (pid < 0) {
			if (errno != EINTR) {
				perror("childSig: wait3 error");
				break;
			}
		}
		else if (WIFSTOPPED(w))
			fprintf(stderr,
			    "childSig: subprocess stopped, signal %d\r\n",
			    w.w_stopsig);
		else if (WIFEXITED(w))
			fprintf(stderr,
			    "childSig: subprocess exited, retcode %d\r\n",
			    w.w_retcode);
		else if (WIFSIGNALED(w))
			fprintf(stderr,
			    "childSig: subprocess signalled, retcode %d\r\n",
			    w.w_termsig);
		else
			warning("childSig: eh?");
		fflush(stderr);
	}
}


static void
findPty(pfdp, tfdp)
int *pfdp, *tfdp;
{
	char ptyName[BUFSIZ];
	char ttyName[BUFSIZ];
	int on = 1, i;
	char c;

	for (*pfdp = *tfdp = -1,  c = 'p';   *tfdp < 0  &&  c <= 'r';   c++)
		for (i = 0;  *tfdp < 0  &&  i < 0x10;  ++i)
			if ((*pfdp
			      = open(sprintf(ptyName, "/dev/pty%c%x", c, i), 2))
			    >= 0)
				if ((*tfdp = open(sprintf(ttyName,
				    "/dev/tty%c%x", c, i), 2))  < 0)
					close(*pfdp);	 /* release pty */

	if (*tfdp < 0) {
		warning ("createProcess: Can't get a pty\n");
		return;
	}

	ioctl(*pfdp, TIOCREMOTE, &on);
	ioctl(*pfdp, FIONBIO, &on);

}
