static char utils_h[] = "$Header: utils.h,v 41.2 84/05/15 23:32:47 hilfingr Exp $";

/*
 *	Copyright (C) 1983 by the Regents of University of California 
 *	All Rights Reserved.
 *
 *	utility routines for BS
 */
/* $Log:	utils.h,v $
 * Revision 41.2  84/05/15  23:32:47  hilfingr
 * Added definition of b2s_utils_defined for use in conditional compilations
 *  */
#define b2s_utils_defined


# ifndef major	/* also in sys/types.h */
	typedef	unsigned int	u_int;
	typedef	unsigned long	u_long;
	typedef	unsigned short	u_short;
	typedef	unsigned char	u_char;
# endif

typedef	int		word_t;		/* a soar word */
typedef int		boolean; 	/* for 68k */

# ifndef FALSE
#	define		FALSE	((boolean)0)
# endif
# ifndef TRUE
#	define		TRUE	(~FALSE)
# endif

extern	char	*malloc(), *sprintf(), *valloc(), *xmalloc(), *xvalloc(),
		*getenv();
extern	void	_adb(), fatal(), xread(), xwrite();
extern	FILE	*xfopen();


/*
 * 	returns the number of elements in an array
 */

# define lengthof(anArray)	(sizeof(anArray) / sizeof(anArray)[0])


/*
 *	Utilities --
 *	They are defined as macros for efficiency reasons.
 */

/*
 *	round x up to multiple of y, y MUST be a power of 2
 */

# define roundUp(x, y) \
	((x) + (y) - 1  &  ~((y) - 1))


/*
 *	Copies words from address "from" to address "to".  If copying
 *	only 0, 1 or 2 words, it will copy word by word using an 
 *	unrolled loop.  Otherwise, it will call wcopy, which does
 *	the copying by using a loop  (cases are slow on 68K).
 */

# define copy_words(from, to, count)  \
	if (TRUE) {\
		if (count == 0)	/* nothing to copy */\
			;\
		else if (count == 1)\
			*(word_t *)(to) = *(word_t *)(from);\
		else if (count == 2) {\
			*(word_t *)(to) = *(word_t *)(from);\
			((word_t *)(to))[1] = ((word_t *)(from))[1];\
		}\
		else\
			wcopy((long *)from, (long *)to, (u_int)count);\
	}\
	else

/*
 *	The adb macro provides labels for adb'ing BS.
 *	It must be disabled to permit use of the C optimizer, which
 *	is confused by the labels.
 */

# ifdef ADB
#	define	adb(label) \
		if (TRUE) {\
			asm("	.globl label");\
			asm("label:");\
			_adb();\
		}\
		else
# else
#	ifdef PROFILE_ADB	/* for gprof */
#		define adb(label) \
			if (TRUE) {\
				asm("	.globl label");\
				asm("label:");\
			}\
			else
#	else
#		define	adb(label)	/* nothing */
#	endif
# endif

# ifndef NOFILE
#	define NOFILE	20
# endif


/*
 *	assertion verification - calls fatal if assertion "cond" is not
 *	satisfied.  Facilitates the debugging of BS.
 */

# ifdef ASSERT
#	define assert(cond, msg) \
		if (!(cond))\
			fatal(msg, NullOop);\
		else if (TRUE)\
			;\
		else
# else
#	define assert(cond, msg)	/* nothing */
# endif
